/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

#ifndef _BINARY_H_
#define _BINARY_H_

#include "define.h"

/***************************************
	1. aIndex\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	char szID[DIS_ID+1];				/* aID */
	char szName[DIS_NAME+1];		    /* a\L*/
	char szKName[DIS_KNAME+1];			/* a\LJi*/
	char szDetailDataOffset[DIS_DETOFFSET+1];		/*ڍ׃f[^ʒu*/
	char szResembleDiseaseOffset[DIS_RESOFFSET+1];		/*ގaʒu*/
	char szResembleDiseaseCounter[DIS_RESCOUNT+1];		/*ގa*/
	char szSelectKbn[DIS_SELKBN+1];					/*̑敪*/
	char szSonOffset[DIS_SONOFFSET+1];					/*qm[hʒu*/
	char szSonCounter[DIS_SONCOUNT+1];					/*qm[h*/
	char szCode[DIS_NORCODE+1];			/*aR[hK*/
	char szExchangeCode[DIS_EXCODE+1];	/*apR[h*/

} DISEASEINDEX;

/***************************************
	2. CIndex\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	char szID[MOD_ID+1];				/* CID */
	char szName[MOD_NAME+1];		    /* C\L*/
	char szKName[MOD_KNAME+1];			/* C\LJi*/
	char szKbn[MOD_KBN+1];				/* C敪*/
	char szDetailDataOffset[MOD_DETOFFSET+1];		/* ڍ׃f[^ʒu*/
	char szSonOffset[MOD_SONOFFSET+1];				/* qm[hʒu*/
	char szSonCounter[MOD_SONCOUNT+1];				/* qm[h*/
	char szNorCode[MOD_NORCODE+1];		/* CR[hK*/
	char szExcluSionCode[MOD_EXCLCODE+1];/* rO[vR[h*/

} MODIFIERINDEX;

/***************************************
	3. L[[hIndex\
***************************************/
/*
L[[hIndext@C̃tB[h\
*/
typedef struct {
	char szKeyword[KEY_WORD+1];			/* L[[h */
	char szDiseaseOffset[KEY_DISOFFSET+1];		        /* aʒu*/
	char szDiseaseCounter[KEY_DISCOUNT+1];			  	/* a*/
	char szModifierOffset[KEY_MODOFFSET+1];				/*Cʒu*/
	char szModifierCounter[KEY_DISCOUNT+1];				/*C*/
} KEYWORDINDEX;

/***************************************
	4. aڍ׍\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	char szID[DIS_ID+1];						/* aID */
	char szName[DIS_NAME+1];					/* a\L*/
	char szKName[DIS_KNAME+1];					/* a\LJi*/
	char szSelectKbn[DIS_SELKBN+1];				/*̑敪*/
	char szExchangeCode[DIS_EXCODE+1];			/*apR[h*/
	char szICD10_1[DIS_ICD101+1];				/*vC}ICDPOR[h*/
	char szICD10_2[DIS_ICD102+1];				/*dރR[h*/
	char szICD10Precision[DIS_ICD10PREC+1];				/*ICD10-1tB[h̒l̊mx*/
	char szICDCandidate[DIS_ICD10CAND+1];				/*ICD10mx*/
	char szReseCode[DIS_RESECODE+1];					/*ZdZR[h*/
	char szReseName[DIS_RESENAME+1];					/*ZdZΉ\L*/
	char szResePrecision[DIS_RESEPREC+1];				/*ZdZΉmx*/
	char szResembleDiseaseCode[DIS_RESCODE+1];   		/*ގaR[h*/
	char szConnectModifierKbnCode[DIS_CONNMODKBN+1];	/*ڑC敪R[h*/
	char szNorCode[DIS_NORCODE+1];							/*aR[hK*/
	char szModifierJumpInfo[DIS_MODJUMPINFO+1];			/*CWv*/

} DISEASEDETAIL,DISEASEDETAIL_TEMP;

/***************************************
	5. Cڍ׍\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	char szID[MOD_ID+1];					/* CID */
	char szName[MOD_NAME+1];				/* C\L*/
	char szKName[MOD_KNAME+1];				/* C\LJi*/
	char szCode[MOD_CODE+1]; 				/* CR[h*/
	char szConnectPosKbn[MOD_CONNPOS+1];	/* ڑʒu敪*/
	char szModifierKbn[MOD_KBN+1];			/* C敪*/
	char szExcluSionCode[MOD_EXCLCODE+1];	/* rO[vR[h*/
	char szReseCode[MOD_RESECODE+1]; 		/* ZdZCR[h*/
	char szMasanCode[MOD_NORCODE+1];		/* CR[hK*/
	char szModifierComment[MOD_COMMENT+1];	/* Cx*/

} MODIFIERDETAIL,MODIFIERDETAIL_TEMP;

/***************************************
	6. L[[hڍ׍\
***************************************/
typedef struct {
	char szID[MOD_ID+1];					/* ID */
	char szDMKbn[KEY_DMKBN+1];				/* aC敪*/
	char szKNKbn[KEY_KNKBN+1];				/* Ji敪*/
	char szSynonymKbn[KEY_SYNKBN+1];		/* `敪*/
	char szVariantKbn[KEY_VARKBN+1];		/* َ̋敪*/
	char sz1stUsed[KEY_NO1KBN+1];			/* Pō̗p\L*/
	char szLangKbn[KEY_LANGKBN+1];			/* 敪*/
	char szAbbrKbn[KEY_ABBRKBN+1];			/* ȗ敪*/
} KEYWORDDETAIL;

/***************************************
	7. CsvMsg
	add by bwg  2002/12/02
***************************************/
typedef struct {
	char szICD10[DIS_ICD101+1];				//ICD10-1
	char szKubun[6+1];						//敪R[h
	char szMsg[40+1];						//bZ[W
} CSV_MSG_FILE;
#endif