/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// ExpansionTools.h: CExpansionTools NX̒`
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXPANSIONTOOLS_H__1622E970_50EF_11D5_80F1_00E04C3E74F5__INCLUDED_)
#define AFX_EXPANSIONTOOLS_H__1622E970_50EF_11D5_80F1_00E04C3E74F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // C V{

#include "define.h"
#include "csvdata.h"
#include "Log.h"
#include "common.h"
#include "MsgId.h"

/////////////////////////////////////////////////////////////////////////////
// CExpansionTools

class CExpansionTools : 
	public IDispatchImpl<IExpansionTools, &IID_IExpansionTools, &LIBID_FXISDBEXPANSIONTOOLSLib>, 
	public ISupportErrorInfo,
	public CComObjectRoot,
	public CComCoClass<CExpansionTools,&CLSID_ExpansionTools>
{
public:
	CExpansionTools() 
	{
		memset(m_szFileVision,SPACE,sizeof(m_szFileVision));	//t@C̃o[W
		memset(m_szDisBasicFile,SPACE,sizeof(m_szDisBasicFile));	//a{t@C
		memset(m_szDisSubFile,SPACE,sizeof(m_szDisSubFile));		//a⏕t@C
		memset(m_szDisItemFile,SPACE,sizeof(m_szDisItemFile));	//aKwڃt@C
		memset(m_szDisTreeFile,SPACE,sizeof(m_szDisTreeFile));	//aKw֌Wt@C
		memset(m_szModBasicFile,SPACE,sizeof(m_szModBasicFile));	//C{t@C
		memset(m_szModSubFile,SPACE,sizeof(m_szModSubFile));		//C⏕t@C
		memset(m_szModItemFile,SPACE,sizeof(m_szModItemFile));	//CKwڃt@C
		memset(m_szModTreeFile,SPACE,sizeof(m_szModTreeFile));	//CKw֌Wt@C
		memset(m_szModKbnFile,SPACE,sizeof(m_szModKbnFile));	//C敪̃t@C
		memset(m_szKeywordFile,SPACE,sizeof(m_szKeywordFile));	//L[[ht@C
		memset(m_szOutPosition,SPACE,sizeof(m_szOutPosition));	//o͐tH_ʒu

		//o̓t@C(oCit@C)
		memset(m_szDisIndex,SPACE,sizeof(m_szDisIndex));		//aIndext@C
		memset(m_szModIndexFile,SPACE,sizeof(m_szModIndexFile));	//CIndext@C
		memset(m_szKeyIndex,SPACE,sizeof(m_szKeyIndex));		//L[[hIndext@C
		memset(m_szDisTreeIndex,SPACE,sizeof(m_szDisTreeIndex));	//aKw֌Wt@C
		memset(m_szModTreeIndex,SPACE,sizeof(m_szModTreeIndex));	//CKw֌Wt@C
		memset(m_szDisDetail,SPACE,sizeof(m_szDisDetail));		//aڍ׃t@C
		memset(m_szModDetail,SPACE,sizeof(m_szModDetail));		//Cڍ׃t@C
		memset(m_szKeyDetail,SPACE,sizeof(m_szKeyDetail));		//L[[hڍ׃t@C
		memset(m_szModKbn,SPACE,sizeof(m_szModKbn));			//C敪t@C
		memset(m_szDisResemble,SPACE,sizeof(m_szDisResemble));	//ގat@C

	}
	~CExpansionTools()
	{
		if(m_hLog != NULL)
		{
			delete m_hLog;
		}
		FreeStruct();
	}
BEGIN_COM_MAP(CExpansionTools)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IExpansionTools)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()
//DECLARE_NOT_AGGREGATABLE(CExpansionTools) 
// IuWFNgŃAOQ[VT|[gȂꍇ 
// ̍sRg폜ĂB 

DECLARE_REGISTRY_RESOURCEID(IDR_ExpansionTools)
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IExpansionTools
public:
	STDMETHOD(SetLogPath)(/*[in]*/BSTR bstrLogPath);

	STDMETHOD(SetExportFile)(BSTR pszDiseaseIndex,BSTR pszModifierIndex,BSTR pszKeywordIndex,BSTR pszDiseaseTreeIndex,BSTR pszModifierTreeIndex,BSTR pszDiseaseDetail,BSTR pszModifierDetail,BSTR pszKeywordDetail,BSTR pszModifierClassification,BSTR pszDiseaseResemble);
	STDMETHOD(DevelopExecute)(int *nResult);
	STDMETHOD(SetImportFile)(BSTR pszFileVision,BSTR pszDiseaseBasicFile,BSTR pszDiseaseSubFile,BSTR pszDiseaseItemFile,BSTR pszDiseaseTreeFile,BSTR pszModifierBasicFile,BSTR pszModifierSubFile,BSTR pszModifierItemFile,BSTR pszModifierTreeFile,BSTR pszModifierNameFile,BSTR pszKeywordFile,BSTR pszOutPosition);

private:
	int MakeKataKeyword(CStringArray &arr,char *pLogOutNo,int nDisModType);
	BOOL IsHadHira(CString strValue);
	void DoWithModBasicRemained();
	void DoWithDisBasicRemained();
	BOOL IsKbn3IdExist(char *pDisId);
	BOOL m_bkbn3Flag;
	void SortModifierDetail_TempList(int nLow,int nHeight);
	void SortDiseaseDetail_TempList(int nLow,int nHeight);
	char m_szLogPath[_MAX_PATH];
	int DevelopProc();
	int CreateDiseaseSubToIndex(int nIndex,int nBasicIndex);
	int CreateModifierSubToIndex(int nIndex,int nBasicIndex);
	BOOL IsDisIdExist(char *pDisID,int &nIndex);
	BOOL IsModIdExist(char *pModID,int &nIndex);
	void Delete_File(char *pBinaryFile);
	int CheckFileType(char *pCsvFile);
	int Create_Keyword_Detail();
	int SelKbnSpePro();
	int Add_DiseaseIndex_TempList(int nIndex,int nBasicIndex,int nSubIndex,int nOldIndex=-1);
	int Develop_Disease_Synonym(int nSubIndex);
	int Develop_Modifier_Synonym(int nSubIndex);
	void Set_Disease_Detail(int nIndex,int nBasicIndex,int nSubIndex);
	void Set_Modifier_Detail(int nIndex,int nBasicIndex,int nSubIndex);
	int  SearchDiseaseBasicList(char *pDiseaseID,int& nIndex);
	int  SearchDiseaseSubList(char *pDiseaseID,int& nIndex);
	int  SearchModifierBasicList(char *pModifierID,int& nIndex);
	int  SearchModifierSubList(char *pModifierID,int& nIndex);
	void SortDisSubFileList(int nLow,int nHeight);
	void SortDisBasicFileList(int nLow,int nHeight);
	void SortModSubFileList(int nLow,int nHeight);
	void SortModBasicFileList(int nLow,int nHeight);
	void SearchDisItemList(char *pItemID,int& nIndex);
	void SearchDisTreeList(char* pFatherID,int& nMinPos,int& nMaxPos);
	void SearchDisTreeListFirst(char* pID,int& nMinPos,int& nMaxPos);
	void SortDisTreeFileList(int nLow,int nHeight);
	int  LocatDisTreeFileList(char *pID,int &nIndex);
	void SortDisItemFileList(int nLow,int nHeight);
	void SearchModItemList(char *pItemID,int& nIndex);
	void SearchModTreeList(char* pFatherID,int& nMinPos,int& nMaxPos);
	void SortModTreeFileList(int nLow,int nHeight);
	void SortModItemFileList(int nLow,int nHeight);

	int Find_DiseaseTree_Son(int nIndex,int& nMinPos,int& nMaxPos);
	int Find_ModifierTree_Son(int nIndex,int& nMinPos,int& nMaxPos);
	void SortDisTreeSegment(CTypedPtrArray<CPtrArray, DISEASE_TREE_FILE*> &arrDisTree,int nLow,int nHeight);
	void SortModTreeSegment(CTypedPtrArray<CPtrArray, MODIFIER_TREE_FILE*> &arrModTree,int nLow,int nHeight);

	int MakeStrTblSpe(char *pStrData,char **pStrTable,int nWordCnt,int nWordLen,char cCutSign);
	int StrLength(int nLength,char *szTemp);
	void Delete_Modifier_BasicAndSub();
	void Delete_Modifier_TreeAndItem();
	void Create_Modifier_Index();
	void Delete_Disease_BasicAndSub();
	void Delete_Disease_TreeAndItem();
	void Create_Disease_Index();

	int WriteFile_Resemble_Disease();
	int WriteFile_Disease_Tree();
	int WriteFile_Disease_Detail();
	int WriteFile_Disease_Index();
	int WriteFile_Modifier_Detail();
	int WriteFile_Modifier_Tree();
	int WriteFile_Modifier_Index();
	int WriteFile_Modifier_Division();
	int WriteFile_KeyWord_Detail();
	int WriteFile_KeyWord_Index();

	int ReadFile_DiseaseBasic();
	int ReadFile_ModifierTree();
	int ReadFile_KeyWord();
	int ReadFile_Modifier_Division();
	int ReadFile_ModifierItem();
	int ReadFile_ModifierSub();
	int ReadFile_ModifierBasic();
	int ReadFile_DiseaseTree();
	int ReadFile_DiseaseItem();
	int ReadFile_DiseaseSub();

	int SetModifierTree(char *pDBRecord, MODIFIER_TREE_FILE *pModifierTree);
	int SetModifierSub(char *pDBRecord, MODIFIER_SUB_FILE *pModifierSub);
	int SetModifierItem(char *pDBRecord, MODIFIER_ITEM_FILE *pModifierItem);
	int SetModifierBasic(char *pDBRecord, MODIFIER_BASIC_FILE *pModifierBasic);
	int SetKeyWord(char *pDBRecord, KEYWORD_FILE *pKeyWord);
	int SetDivisionFile(char *pDBRecord, MODIFIER_DIVISION_FILE *pModDivision);
	int SetDiseaseTree(char *pDBRecord, DISEASE_TREE_FILE *pDiseaseTree);
	int SetDiseaseBasic(char *pDBRecord, DISEASE_BASIC_FILE *pDiseaseBasic);
	int SetDiseaseSub(char *pDSRecord, DISEASE_SUB_FILE *pDiseaseSub);
	int SetDiseaseItem(char *pDBRecord, DISEASE_ITEM_FILE *pDiseaseItem);

	int Add_KeyWordIndex_TempList(int nFileIndex,int nInsertIndex,CStringArray &arrID);
	int Create_Modifier_Detail();
	int Create_DevelopResemble();
	int Create_Disease_Detail();
	int Update_KeyWordIndex_TempList(int nKeyFileIndex,int nKeyTempIndex,CStringArray &arrID);

	void FreeStruct();
	int Find_KeyWord_TempList(char *pKeyword,int &nIndex,BOOL &bFinded);
	int Find_Modifier_Item(char *pID, char *pModifierItemName);
	int Find_Modifier_ID(char *pExChange, CStringArray &arrModifierID);
	int Find_KeywordIndex_TempList(char *pKeyword, int &Index);
	int Find_DiseaseIndexTempExChangeCode(char *pExChangeCode, int &nIndex);
	int Find_DiseaseIndex_TempList(char *pDiseaseID, int &nIndex);
	int Find_Disease_Item(char *pID, char *pDiseaseItemName);
	int Find_Disease_ID(char *pExChange,CStringArray &arrDiseaseID);

	int StripDoubleQuotation(char** pValue, int nCount);
	int ConverArray(VARIANT oSufDevelopWords,CStringArray *strSufDevelopWords,int nDevelopNums);
	int SetOutFilePath();

	//̓t@C(CSVt@C)
	TCHAR m_szFileVision[FILEVERSION+1];	//t@C̃o[W
	TCHAR m_szDisBasicFile[_MAX_PATH];	//a{t@C
	TCHAR m_szDisSubFile[_MAX_PATH];		//a⏕t@C
	TCHAR m_szDisItemFile[_MAX_PATH];	//aKwڃt@C
	TCHAR m_szDisTreeFile[_MAX_PATH];	//aKw֌Wt@C
	TCHAR m_szModBasicFile[_MAX_PATH];	//C{t@C
	TCHAR m_szModSubFile[_MAX_PATH];		//C⏕t@C
	TCHAR m_szModItemFile[_MAX_PATH];	//CKwڃt@C
	TCHAR m_szModTreeFile[_MAX_PATH];	//CKw֌Wt@C
	TCHAR m_szModKbnFile[_MAX_PATH];	//C敪̃t@C
	TCHAR m_szKeywordFile[_MAX_PATH];	//L[[ht@C
	TCHAR m_szOutPosition[_MAX_PATH];	//o͐tH_ʒu

	//o̓t@C(oCit@C)
	TCHAR m_szDisIndex[_MAX_PATH];		//aIndext@C
	TCHAR m_szModIndexFile[_MAX_PATH];	//CIndext@C
	TCHAR m_szKeyIndex[_MAX_PATH];		//L[[hIndext@C
	TCHAR m_szDisTreeIndex[_MAX_PATH];	//aKw֌Wt@C
	TCHAR m_szModTreeIndex[_MAX_PATH];	//CKw֌Wt@C
	TCHAR m_szDisDetail[_MAX_PATH];		//aڍ׃t@C
	TCHAR m_szModDetail[_MAX_PATH];		//Cڍ׃t@C
	TCHAR m_szKeyDetail[_MAX_PATH];		//L[[hڍ׃t@C
	TCHAR m_szModKbn[_MAX_PATH];			//C敪t@C
	TCHAR m_szDisResemble[_MAX_PATH];	//ގat@C

	//t@C̓ǂݎpϐ
//	CStdioFile m_File;
	//a{e[ũXg
	CTypedPtrArray <CPtrArray, DISEASE_BASIC_FILE * > m_DiseaseBasicList;
	//a⏕e[ũXg
	CTypedPtrArray <CPtrArray, DISEASE_SUB_FILE * > m_DiseaseSubList;
	//C{e[ũXg
	CTypedPtrArray <CPtrArray, MODIFIER_BASIC_FILE * > m_ModifierBasicList;
	//C⏕e[ũXg
	CTypedPtrArray <CPtrArray, MODIFIER_SUB_FILE * > m_ModifierSubList;
	//L[[he[ũXg
	CTypedPtrArray <CPtrArray, KEYWORD_FILE * > m_KeyWordList;
	//PŗpΉe[ũXg
//	CTypedPtrArray <CPtrList, EQUIVALENCE_FILE * > m_EquivalenceList;
	//aKwڃe[ũXg
	CTypedPtrArray <CPtrArray, DISEASE_ITEM_FILE * > m_DiseaseItemList;
	//aKw֌We[ũXg
	CTypedPtrArray <CPtrArray, DISEASE_TREE_FILE * > m_DiseaseTreeList;

	//CKwڃe[ũXg
	CTypedPtrArray <CPtrArray, MODIFIER_ITEM_FILE * > m_ModifierItemList;
	//CKw֌We[ũXg
	CTypedPtrArray <CPtrArray, MODIFIER_TREE_FILE * > m_ModifierTreeList;
	//C敪̃e[ũXg
	CTypedPtrArray <CPtrArray, MODIFIER_DIVISION_FILE * >m_ModifierDivisionList;

	//aڍ׃e|\̃Xg
	CTypedPtrArray <CPtrArray, DISEASEDETAIL_TEMP * > m_DiseaseDetail_TempList;
	//Cڍ׃e|\̃Xg
	CTypedPtrArray <CPtrArray, MODIFIERDETAIL_TEMP * > m_ModifierDetail_TempList;
	//L[[he|\̃Xg
	CTypedPtrArray <CPtrArray, KEYWORDINDEX_TEMP * > m_KeyWordIndex_TempList;
	//aIndexe|\̃Xg
	CTypedPtrArray <CPtrArray, DISEASEINDEX_TEMP * > m_DiseaseIndex_TempList;
	//CIndexe|\̃Xg
	CTypedPtrArray <CPtrArray, MODIFIERINDEX_TEMP * > m_ModifierIndex_TempList;
	CTypedPtrArray <CPtrArray, KEYWORDDETAIL * > m_KeyWordDetailList;
	//ގae|\̃Xg
	CTypedPtrArray <CPtrArray, RESEMBLEDISEASE_TEMP * > m_ResembleDisease_TempList;

	XCLOGH m_hLog;
};

#endif // !defined(AFX_EXPANSIONTOOLS_H__1622E970_50EF_11D5_80F1_00E04C3E74F5__INCLUDED_)
