/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// BasicDBAccess.h: BasicDBAccess NX̒`
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASICDBACCESS_H__18D0EBCF_61F8_11D5_810B_00E04C3E74F5__INCLUDED_)
#define AFX_BASICDBACCESS_H__18D0EBCF_61F8_11D5_810B_00E04C3E74F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // C V{
#include "ResultNodeList.h"
#include "MedicalSearch.h"

/////////////////////////////////////////////////////////////////////////////
// BasicDBAccess
extern MedicalSearch gMedicalSearch;

class BasicDBAccess : 
	public IDispatchImpl<IBasicDBAccess, &IID_IBasicDBAccess, &LIBID_FXISDISEASEBASICDBACCESSLib>, 
	public ISupportErrorInfo,
	public CComObjectRoot,
	public CComCoClass<BasicDBAccess,&CLSID_BasicDBAccess>
{
public:
	BasicDBAccess() 
	{
	}

BEGIN_COM_MAP(BasicDBAccess)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IBasicDBAccess)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()
//DECLARE_NOT_AGGREGATABLE(BasicDBAccess) 
// IuWFNgŃAOQ[VT|[gȂꍇ 
// ̍sRg폜ĂB 

DECLARE_REGISTRY_RESOURCEID(IDR_BasicDBAccess)
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IBasicDBAccess
public:
	STDMETHOD(SearchDiseaseKeywordAnd)(/*[in]*/int nRetrieveSegerRange,/*[in]*/BSTR szDiseasePath,/*[in]*/BSTR szKeyword,/*[in]*/BSTR szSynonymKbn,/*[in]*/int nMostRetrieveNum,/*[out]*/VARIANT_BOOL* bOutReward,/*[out]*/VARIANT_BOOL* bOutNumOver,/*[out,retval]*/VARIANT* retval);
	STDMETHOD(SearchCompatibleDisease)(/*[in]*/BSTR szExchangeCode,/*[out]*/BSTR *lpszDiseaseID);
	STDMETHOD(SearchCodingInfo)(/*[in]*/BSTR szICD10, /*[out]*/BSTR *lpszMsg);
	STDMETHOD(InitializeCodingInfo)(/*[in]*/BSTR FileName);
	STDMETHOD(ConvertHiraKata)(/*[in]*/int nChangeType,/*[in]*/BSTR szPreWords,/*[out]*/BSTR *lpszSufWords);
	STDMETHOD(SearchModifierCodeKeyword)(/*[in]*/BSTR szModifierCode,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(SearchExchangeCodeKeyword)(/*[in]*/BSTR szExchangeCode,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(GetModPath)(/*[in]*/BSTR szId,/*[out]*/BSTR *szPath);
	STDMETHOD(GetBasicModifierID)(BSTR szInModifier,BSTR *lpszOutModifierID);
	STDMETHOD(GetBasicModifierCode)(/*[in]*/BSTR szInModifier,/*[out]*/BSTR *lpszOutModifierCode);
	STDMETHOD(DevelopWord)(BSTR szPreDevelopWords,VARIANT *pArrSufDevelopWord,int *nDevelopNums);
	STDMETHOD(SortModifierCode)(int nCount,VARIANT arrInModifierPos,VARIANT arrInModifierCode,VARIANT *pOutModifierSortCode);
//	STDMETHOD(SortModifierCode)(int nCount,VARIANT oInModifierSortCode,VARIANT *pOutModifierSortCode);
	STDMETHOD(GetFileVersion)(BSTR szFilePath,BSTR *lpszFileVersion);
//	STDMETHOD(GetBasicModifier)(BSTR szInModifier,BSTR *lpszOutModifierCode);
	STDMETHOD(EqualsSynonym)(BSTR szPreCmpDiseaseName,BSTR szSufCmpDiseaseName,VARIANT_BOOL *bCmpResult);
	STDMETHOD(DecomposeDiseasePath)(BSTR *lpszDiseasePath,BSTR *lpszDisease);
	STDMETHOD(ConvertWord)(BSTR szPreChgWords,BSTR *lpszSufChgWords);
	STDMETHOD(ConvertUpperLower)(int nChangeType,BSTR szPreChgWords,BSTR *lpszSufChgWords);
	STDMETHOD(ConvertHyphen)(BSTR szPreChgWords,BSTR *lpszSufChgWords);
	STDMETHOD(ConvertDoubleSingleWord)(int nKanaChangeType,int nAlphabetChangeType,BSTR szPreChgWords,BSTR *lpszSufChgWords);
	STDMETHOD(AddDiseasePath)(BSTR szDiseaseID,BSTR *lpszDiseasePath);
	STDMETHOD(CheckExclusive)(/*[in]*/BSTR szModifierID,/*[in]*/VARIANT oArrInModiferID,/*[in]*/int nInModCnt,/*[out]*/VARIANT_BOOL *bOutCheckResult);
	STDMETHOD(GetNormallzatlonDiseaseCode)(/*[in]*/BSTR szDiseaseID,/*[in]*/VARIANT ArrInModifierID,/*[in]*/int nModifierNum,/*[out]*/BSTR *szDiseaseNameExchangeCode,/*[out]*/BSTR *szOutDiseaseId,/*[out]*/VARIANT *pOutArrModiferCode,/*[out]*/int *nOutModifierNum);
	STDMETHOD(GetLatestErrorCode)(/*[out]*/ long *nErrCode);
	STDMETHOD(GetKeywordDetail)(/*[in]*/ BSTR strKeyWord, /*[in]*/ BSTR strID,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(GetModifierDetail)(/*[in]*/ BSTR strID,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(GetDiseaseDetail)(/*[in]*/ BSTR strID,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(GetModifierJumpItem)(/*[in]*/ BSTR strDiseaseID,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(GetModifierNode)(/*[in]*/ BSTR strModifierPath, /*[in]*/ BSTR strModifierID,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(SearchModifierKeyword)(/*[in]*/ BSTR strKeyWord,/*[in]*/ BSTR strSynonym,/*[in]*/ int nRetrieveType,/*[in]*/ int nMaxRetrieveNum,/*[out]*/ VARIANT_BOOL *bOutReward,/*[out]*/ VARIANT_BOOL *bOutCntOver,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(SearchPartModifier)(/*[in]*/ BSTR strModifierKbn,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(GetConnectiveModifierCategory)(/*[in]*/ BSTR strDiseaseID,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(SearchConnectiveModifier)(/*[in]*/ BSTR strDiseaseID,/*[in]*/ BSTR strModifierKbn,/*[out, retval]*/ VARIANT* retval);
	STDMETHOD(SearchResembleDisease)(/*[in]*/int nRetrieveSegerRange,/*[in]*/BSTR szDiseaseID,VARIANT* retval);
	STDMETHOD(SearchDiseaseKeyword)(int nRetrieveSegerRange,BSTR szDiseasePath,BSTR szKeyword,BSTR szSynonymKbn,int nRetrieveType,int nMostRetrieveNum,/*[out]*/VARIANT_BOOL *bOutReward,/*[out]*/VARIANT_BOOL *bOutNumOver,/*[out,retval]*/VARIANT* retval);
	STDMETHOD(GetDiseaseNode)(int nRetrieveSegerRange, BSTR strDiseasePath,VARIANT* retval);
	STDMETHOD(Initialize)(BSTR szDiseaseIndex,BSTR szModifierIndex,BSTR szKeywordIndex,BSTR szDiseaseTreeIndex,BSTR szModifierTreeIndex,BSTR szDiseaseDetail,BSTR szModifierDetail,BSTR szKeywordDetail,BSTR szModifierClassification,BSTR szDiseaseResemble);

protected:
//	CComObject<CResultNodeList> *m_pResultNodeList;
private:
//	int StrArrToVariant(CStringArray &oInArray,VARIANT *pVar);
//	int VariantToStrArr(int nCount,VARIANT *pVar,CStringArray &OutArr);
};

#endif // !defined(AFX_BASICDBACCESS_H__18D0EBCF_61F8_11D5_810B_00E04C3E74F5__INCLUDED_)
