/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// MedicalSearch.h: MedicalSearch NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEDICALSEARCH_H__9E1AE694_6454_11D5_818D_00E04C3E2DA0__INCLUDED_)
#define AFX_MEDICALSEARCH_H__9E1AE694_6454_11D5_818D_00E04C3E2DA0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DBStruct.h"
#include "resource.h"		// C V{
#include "memoData.h"
#include "binarydata.h"
#include "FileAccess.h"
 

class MedicalSearch  
{
public:
	MedicalSearch();
	virtual ~MedicalSearch();

private:
	int MakeModTree(char* pModStateRelationFile,CTypedPtrArray <CPtrArray,MODIFIERINDEX*> &arrModIndexFile);
	int MakeDisTree(char* pDisStateRelationFile,CTypedPtrArray <CPtrArray,DISEASEINDEX*> &arrDisIndexFile);
	int MakeIndexForDisIndex();
	int MakeIndexForModIndex();
	int MakeNorCodeForDisIndex();
	int ReadDisIndex(char *pDisIndexFile, CTypedPtrArray <CPtrArray,DISEASEINDEX*> &arrDisIndexFile);
	int ReadModIndex(char *pModIndexFile, CTypedPtrArray <CPtrArray,MODIFIERINDEX*> &arrModIndexFile);
	void GetInsertPosition(CStringArray &arrSrc, CString strInsert, int &nIndex);
	int AddElement(CString strAdd, CStringArray &strArrSource, CStringArray &strArrOut,BOOL bHaveDis);
	int GetModDetailFromCode(char *pCode, MODIFIERDETAIL &oModDetail);
	int GetModBestCombine(CStringArray &arrSrc, CStringArray &arrDestCode, CStringArray &arrDestID);
	int MakeSortedNorCode(char *pNorCode,CStringArray &arrNorCode, BOOL bHaveDis);
	void SortSynonymWord(CStringArray &arr,int nCount);
	BOOL IsSameDiseaseNameExist(StructResultDisease *pStructResultDisease,CTypedPtrArray<CPtrArray,StructResultDisease*> &arr);
	BOOL IsSameModifierNameExist(StructResultModifier *pStructResultModifier,CTypedPtrArray <CPtrArray,StructResultModifier*> &arr);
	void SortModifierKeywordBySynonym(CTypedPtrArray <CPtrArray,StructResultModifier*> &arr,StructResultModifier* pModifier,CString strInKeyword,int &nIndex,BOOL &bFinded);
	void SortDiseaseKeywordBySynonym(CTypedPtrArray <CPtrArray,StructResultDisease*> &arr,StructResultDisease* pDisease,CString strInKeyword,int &nIndex,BOOL &bFinded);
	BOOL IsValidSynonymKbn(CString strBaseData,CString strSynonym);
	void SortKeyword(CArray<StructResultKeyword*,StructResultKeyword*> &arr,int nCount);
	BOOL AddLastZero(CString &strValue);
	BOOL IsSamePathExist(StructResultDisease* pStructResultDisease,int &nIndex,CArray<StructResultDisease*,StructResultDisease*> &arr);
	int DoWithModKbnFile(char*szModKbnFile);
	int DoWithKeyword(char*szKeywordFile);
	int DoWithMod(char*szModFile,char*szModStageRelationFile);
	int DoWithDis(char*szDisFile,char*szDisStateRelationFile);
	int TrimNorCode(char* pSrc, char* pDest, CStringArray &arrRes, BOOL bHaveDis);
	int NormalCodeBinarySearchDisease(CString strCode);
	int BinarySearchDisease(CString strID);
	int BinarySearchModifier(CString strID);
	int CombineArray(CStringArray &strArrSource,CStringArray &strArrOut,BOOL bHaveDis);
	void SortByDisKName(CArray<StructResultDisease*,StructResultDisease*>&arrResDis,int low,int high);
	void SortByKeywordPath(CArray<StructResultDisease*,StructResultDisease*>&arr,int n);
	void SortByKeywordId(CArray<StructResultModifier*,StructResultModifier*>&arr,int n);
	void SortByModNameK(CArray<StructResultModifier*,StructResultModifier*>&arrResMod,int low,int high);
	void SortDisByNorCd(/*CArray<memoNormalCode*,memoNormalCode*> &arrmemoDisNor,*/int low,int high);
	void SortDisIndexList(CArray<memoDisease*,memoDisease*> &arrmemoDis,int low,int high);
	void SortModIndexList(CArray<memoModifier*,memoModifier*> &arrmemoMod,int low,int high);
	int GetDiseasePath(char* lpszID, CString &strPath);
	CTypedPtrArray <CPtrArray, CSV_MSG_FILE * > m_MsgList;
	/********************************************************************/
	/*  Add by L@  2002/12/02										*/
	/*  @\FCSVt@C @݁@@̔					    */
	/********************************************************************/
	int CheckFileExist(char* pCsvFile);
	int SetMsgList(char *pDBRecord, CSV_MSG_FILE *pMsgFile);
	int StripDoubleQuotation(char **pValue, int nCount);
	int MakeStrTblSpe(char *pStrData, char **pStrTable, int nWordCnt, int nWordLen, char cCutSign);
	void SortMsgFileList(int nLow, int nHeight);
	int GetQueryType(CString strKeyWord,CString &lpKeyWord);
	void SortDiseaseKeyword(CTypedPtrArray <CPtrArray,StructResultDisease*> &arr,StructResultDisease* pDisease,CString strInKeyword,int &nIndex,BOOL &bFinded);
	/********************************************************************/
	//vB
	BOOL IsPartEqual(int nRetrieveType, char *lpszTarget, char *lpszDest);
	//ڑC敪v.
	int IsStrFit(char* szRes);
	BOOL g_Initialize;//TrueFς   FalseFiKlj
	/********************************************************************/
	/*  Add by L@  2002/12/02										*/
	/*  @\FCSVt@C @݁@@̔						*/
	/********************************************************************/
	BOOL g_InitializeCodingInfo;//TrueFς   FalseFiKlj
	/********************************************************************/

	long g_LngErrorCode;//G[ꍇAG[R[hݒ肳B
	//ŕaINDEXXgB
	CArray <memoDisease*,memoDisease*> m_arrmemoDisease;
	//ŏCINDEXXgB
	CArray <memoModifier*,memoModifier*> m_arrmemoModifier;
	//aINDEXւ̕apXgB
	CTypedPtrArray <CPtrArray,memoDiseaseIndex*> m_arrmemoDiseaseIndex;
	//CINDEXւ̏CꌟpXgB
	CArray <memoModifierIndex*,memoModifierIndex*> m_arrmemoModifierIndex;
//	CList <MODIFIERINDEX*,MODIFIERINDEX*> m_listModifierIndex;
	CArray <memoKeyword*,memoKeyword*> m_arrmemoKeyWord;
	CArray <memoJumpItem*,memoJumpItem*> m_arrmemoJumpItem;
	CTypedPtrArray <CPtrArray,memoNormalCode*> m_arrNormalCode;
	//aڍ׃t@C
	CXipsFileAccess *m_fileDiseaseDetail;
	//Cڍ׃t@C
	CXipsFileAccess *m_fileModifierDetail;
	//L[[hڍ׃t@C
	CXipsFileAccess *m_fileKeyWordDetail;
	//C敪t@C
	CXipsFileAccess *m_fileModifyKbn;
	//ގat@C
	CXipsFileAccess *m_fileSimilarDiseaseName;
public:
	/********************************************************************/
	/*  Add by L@  2002/11/29										*/
	/*  @\Ft@Cǂ݂܂										*/
	/********************************************************************/
	int InitializeCoding(CString strFilePath);
	int GetCsvMsg(BSTR szICD10,BSTR *lpszMsg);
	int GetDiseaseID(BSTR szExchangeCode,BSTR *lpszDiseaseID);
	int SearchDiseaseKeywordAnd(int nRetrieveSegerRange,CString strDiseasePath,CString strKeyWord,CString strSynonymKbn,int nMaxRetrieveNum,CTypedPtrArray <CPtrArray, StructResultDisease*> *liststructResultDisease,BOOL *bReward,BOOL *bNumOver);
	/********************************************************************/
	int SearchModifierKeyword(CString strKeyWord,CString strSynonymKbn,int nRetrieveType,int nMaxRetrieveNum,CTypedPtrArray <CPtrArray, StructResultModifier*> *listStructResultModifier,BOOL *bReward,BOOL *bCntOver);
	int SearchDiseaseKeyword(int nRetrieveSegerRange,CString strDiseasePath,CString strKeyWord,CString strSynonymKbn,int nRetrieveType,int nMaxRetrieveNum,CTypedPtrArray <CPtrArray, StructResultDisease*> *liststructResultDisease,BOOL *bReward,BOOL *bNumOver);
	int ConvertHiraKata(int nChangeType, CString strData, CString &strResults);
	int SearchModifierCodeKeyword(CString strModifierCode,CTypedPtrList <CPtrList, StructResultKeyword*> *listStructResultKeyword);
	int SearchExchangeCodeKeyword(CString strExchangeCode,CTypedPtrList <CPtrList, StructResultKeyword*> *listStructResultKeyword);
	int GetModifierPath(CString strID,CString &strPath);
//	CMedicalSearchApp();
//	~CMedicalSearchApp();
	//
	int Initialize(CString strDiseaseNameID, CString strModifyWord, CString strKeyWord, CString strDiseaseStateRelation, CString strModifierStateRelation, CString strDiseaseNameDetail, CString strModifyWordDetais, CString strKeyWordDetail, CString strModifierKbn, CString strSimilarDiseaseName);
	//am[hXg擾
	int GetDiseaseNode(int nRetrieveSegerRange,CString strDiseasePath,CTypedPtrList <CPtrList, StructResultDiseaseNode * > *listStructResultDiseaseNode);
	//aL[[h
//	int SearchDiseaseKeyword(int nRetrieveSegerRange,CString strDiseasePath,CString strKeyWord,int nRetrieveType,int nMaxRetrieveNum,CTypedPtrList <CPtrList, StructResultDisease * > *liststructResultDisease,BOOL *bReward,BOOL *bNumOver);
	//ގa
	int SearchResembleDisease(int nRetrieveSegerRange,CString strDiseaseID,CTypedPtrList <CPtrList, StructResultDisease * > *liststructResultDisease);
	//ǂgCꌟ
	int SearchConnectiveModifier(CString strDiseaseID,CString strModifierKbn,CTypedPtrList <CPtrList, StructResultModifier * > *liststructResultModifier);
	//ڑC敪擾
	int GetConnectiveModifierCategory(CString strDiseaseID,CArray <StructResultConnectiveModifierCategory*,StructResultConnectiveModifierCategory*> &listResultConnectiveModifierCategory);
	//C敪
	int SearchPartModifier(CString strModifierKbn,CTypedPtrList <CPtrList, StructResultModifier * > *listStructResultModifier);
	//CL[[h
//	int SearchModifierKeyword(CString strKeyWord,int nRetrieveType,int nMaxRetrieveNum,CTypedPtrList <CPtrList, StructResultModifier * > *listStructResultModifier,BOOL *bReward,BOOL *bCntOver);
	//Cm[hXg擾
	int GetModifierNode(CString strModifierPath,CString strModifierID,CTypedPtrList <CPtrList, StructResultModifierNode * >*listStructResultModifierNode);
	//CWvhbv_Eڎ擾
	int GetModifierJumpItem(CString strDiseaseID,StructResultJumpItem &oStructResultJumpItem);
	//aڍ׏擾
	int GetDiseaseDetail(CString strID,DISEASEDETAIL &oStructDiseaseDetail);
	//apR[hK
	int GetModifierDetail(CString strID,MODIFIERDETAIL &oStructModifierDetail);
	//Cڍ׏擾
	int GetKeywordDetail(CString strKeyWord,CString strID,KEYWORDDETAIL &oStructKeywordDetail);
	//Cr`FbN
	int GetNormalizationDiseaseCode(CString strDiseaseID,CStringArray &arrInModiferID,int nModifierNum,CString &strDisExchangeCode,CString &strDisOutID,CStringArray &arrOutModiferID,int &nModifierNumOut);
//	int GetNormalizationDiseaseCode(CString strDiseaseID,CStringArray  strarrInModiferID,int nModifierNum,CString &strDiseaseNameExchangeCode,CString &strDiseaseIdOut,CStringArray &strarrOutModiferID,int &nModifierNumOut);
	//L[[hڍ׏擾
	int CheckExclusive(CString strModifierID,CStringArray &strArrInModiferID,BOOL &bCheckResult);
	//G[ID擾
	int GetLatestErrorCode(long &lErrCode);
	//C
	int GetModifierCD(CString strRes1,CString strRes2,CString &strDest);

//[eBeBC^tF[X
	int AddDiseasePath(BSTR szDiseaseID,BSTR *lpszDiseasePath);
	int ConvertDoubleSingleWord(int nKanaChangeType,int nAlphabetChangeType,BSTR szPreChgWords,BSTR *lpszSufChgWords);
	int ConvertHyphen(BSTR szPreChgWords,BSTR *lpszSufChgWords);
	int ConvertUpperLower(int nChangeType,BSTR szPreChgWords,BSTR *lpszSufChgWords);
	int ConvertWord(BSTR szPreChgWords,BSTR *lpszSufChgWords);
	int DecomposeDiseasePath(BSTR *lpszDiseasePath,BSTR *lpszDiseaseID);
	int DevelopWord(BSTR szPreDevelopWords,VARIANT *pArrSufDevelopWords, int *nDevelopNums);
	int EqualsSynonym(BSTR szPreCmpDiseaseName,BSTR szSufCmpDiseaseName,BOOL *bCmpResult);
//	int GetBasicModifier(BSTR szInModifier,BSTR *lpszOutModifierCode);
	int GetFileVersion(BSTR szFilePath,BSTR *lpszFileVersion);
	int SortModifierCode(int nCount,VARIANT arrInModifierPos,VARIANT arrInModifierCode,VARIANT *pOutModifierSortCode);
	//	int SortModifierCode(int nCount,VARIANT oInModifierSortCode,VARIANT *pOutModifierSortCode);
	int DevelopBracket(CString &strTemp1,CString &strTemp2);
	int DevelopCurve(CStringArray &Array1,CStringArray &Array2);
	int MakeNewStrBracket(CString &strChangePrev, CString &strChangeSuf);
	int MakeNewStrCurve(CString strChangePrev, CStringArray &strArraySuf);
	int GetBasicModifierID(BSTR szInModifier,BSTR *lpszOutModifierID);
	int GetBasicModifierCode(BSTR szInModifier,BSTR *lpszOutModifierCode);

};
extern	int StrArrToVariant(CStringArray &oInArray,VARIANT *pVar);
extern	int VariantToStrArr(int nCount,VARIANT *pVar,CStringArray &OutArr);

#endif // !defined(AFX_MEDICALSEARCH_H__9E1AE694_6454_11D5_818D_00E04C3E2DA0__INCLUDED_)
