/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwta@Ï񕔁A				*
*						xm[bNXVXeBSƕ					*
*                                                                           *
****************************************************************************/

// ClassWizard ɂĎꂽ IDispatch bv NX
/////////////////////////////////////////////////////////////////////////////
// IBasicDBAccess bv NX

class IBasicDBAccess : public COleDispatchDriver
{
public:
	IBasicDBAccess() {}		// COleDispatchDriver ftHg RXgNV
	IBasicDBAccess(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IBasicDBAccess(const IBasicDBAccess& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	void Initialize(LPCTSTR szDiseaseIndex, LPCTSTR szModifierIndex, LPCTSTR szKeywordIndex, LPCTSTR szDiseaseTreeIndex, LPCTSTR szModifierTreeIndex, LPCTSTR szDiseaseDetail, LPCTSTR szModifierDetail, LPCTSTR szKeywordDetail, 
		LPCTSTR szModifierClassification, LPCTSTR szDiseaseResemble);
	VARIANT GetDiseaseNode(long nRetrieveSegerRange, LPCTSTR strDiseasePath);
	VARIANT SearchDiseaseKeyword(long nRetrieveSegerRange, LPCTSTR szDiseasePath, LPCTSTR szKeyword, long nRetrieveType, long nMostRetrieveNum, BOOL* bOutReward, BOOL* bOutNumOver);
	VARIANT SearchResembleDisease(long nRetrieveSegerRange, LPCTSTR szDiseaseID);
	VARIANT SearchConnectiveModifier(LPCTSTR strDiseaseID, LPCTSTR strModifierKbn);
	VARIANT GetConnectiveModifierCategory(LPCTSTR strDiseaseID);
	VARIANT SearchPartModifier(LPCTSTR strModifierKbn);
	VARIANT SearchModifierKeyword(LPCTSTR strKeyWord, long nRetrieveType, long nMaxRetrieveNum, BOOL* bOutReward, BOOL* bOutCntOver);
	VARIANT GetModifierNode(LPCTSTR strModifierPath, LPCTSTR strModifierID);
	VARIANT GetModifierJumpItem(LPCTSTR strDiseaseID);
	VARIANT GetDiseaseDetail(LPCTSTR strID);
	VARIANT GetModifierDetail(LPCTSTR strID);
	VARIANT GetKeywordDetail(LPCTSTR strKeyWord, LPCTSTR strID);
	void GetLatestErrorCode(long* nErrCode);
};
/////////////////////////////////////////////////////////////////////////////
// IResultDiseaseNode bv NX

class IResultDiseaseNode : public COleDispatchDriver
{
public:
	IResultDiseaseNode() {}		// COleDispatchDriver ftHg RXgNV
	IResultDiseaseNode(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultDiseaseNode(const IResultDiseaseNode& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetStrID();
	void SetStrID(LPCTSTR lpszNewValue);
	CString GetStrName();
	void SetStrName(LPCTSTR lpszNewValue);
	CString GetStrKName();
	void SetStrKName(LPCTSTR lpszNewValue);
	CString GetStrSelectKbn();
	void SetStrSelectKbn(LPCTSTR lpszNewValue);
	CString GetStrPath();
	void SetStrPath(LPCTSTR lpszNewValue);
	BOOL GetBLost();
	void SetBLost(BOOL bNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IResultNodeList bv NX

class IResultNodeList : public COleDispatchDriver
{
public:
	IResultNodeList() {}		// COleDispatchDriver ftHg RXgNV
	IResultNodeList(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultNodeList(const IResultNodeList& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	LPUNKNOWN Get_NewEnum();
	long GetCount();
	VARIANT GetItem(long Index);
};
/////////////////////////////////////////////////////////////////////////////
// IResultDisease bv NX

class IResultDisease : public COleDispatchDriver
{
public:
	IResultDisease() {}		// COleDispatchDriver ftHg RXgNV
	IResultDisease(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultDisease(const IResultDisease& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetStrID();
	void SetStrID(LPCTSTR lpszNewValue);
	CString GetStrName();
	void SetStrName(LPCTSTR lpszNewValue);
	CString GetStrKName();
	void SetStrKName(LPCTSTR lpszNewValue);
	CString GetStrSelectKbn();
	void SetStrSelectKbn(LPCTSTR lpszNewValue);
	CString GetStrSynonymKbn();
	void SetStrSynonymKbn(LPCTSTR lpszNewValue);
	CString GetStrKeyWord();
	void SetStrKeyWord(LPCTSTR lpszNewValue);
	CString GetStrPath();
	void SetStrPath(LPCTSTR lpszNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IResultModifier bv NX

class IResultModifier : public COleDispatchDriver
{
public:
	IResultModifier() {}		// COleDispatchDriver ftHg RXgNV
	IResultModifier(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultModifier(const IResultModifier& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetStrID();
	void SetStrID(LPCTSTR lpszNewValue);
	CString GetStrName();
	void SetStrName(LPCTSTR lpszNewValue);
	CString GetStrKName();
	void SetStrKName(LPCTSTR lpszNewValue);
	CString GetStrSynonymKbn();
	void SetStrSynonymKbn(LPCTSTR lpszNewValue);
	CString GetStrKeyWord();
	void SetStrKeyWord(LPCTSTR lpszNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IResultModifierNode bv NX

class IResultModifierNode : public COleDispatchDriver
{
public:
	IResultModifierNode() {}		// COleDispatchDriver ftHg RXgNV
	IResultModifierNode(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultModifierNode(const IResultModifierNode& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetStrID();
	void SetStrID(LPCTSTR lpszNewValue);
	CString GetStrName();
	void SetStrName(LPCTSTR lpszNewValue);
	CString GetStrKName();
	void SetStrKName(LPCTSTR lpszNewValue);
	CString GetStrPath();
	void SetStrPath(LPCTSTR lpszNewValue);
	BOOL GetBLost();
	void SetBLost(BOOL bNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IResultConnectiveModifierCategory bv NX

class IResultConnectiveModifierCategory : public COleDispatchDriver
{
public:
	IResultConnectiveModifierCategory() {}		// COleDispatchDriver ftHg RXgNV
	IResultConnectiveModifierCategory(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultConnectiveModifierCategory(const IResultConnectiveModifierCategory& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetStrKbn();
	void SetStrKbn(LPCTSTR lpszNewValue);
	CString GetStrName();
	void SetStrName(LPCTSTR lpszNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IResultModifierJumpItem bv NX

class IResultModifierJumpItem : public COleDispatchDriver
{
public:
	IResultModifierJumpItem() {}		// COleDispatchDriver ftHg RXgNV
	IResultModifierJumpItem(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IResultModifierJumpItem(const IResultModifierJumpItem& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetStrJumpInfo();
	void SetStrJumpInfo(LPCTSTR lpszNewValue);
	CString GetStrName();
	void SetStrName(LPCTSTR lpszNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IDiseaseDetail bv NX

class IDiseaseDetail : public COleDispatchDriver
{
public:
	IDiseaseDetail() {}		// COleDispatchDriver ftHg RXgNV
	IDiseaseDetail(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IDiseaseDetail(const IDiseaseDetail& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetSzID();
	void SetSzID(LPCTSTR lpszNewValue);
	CString GetSzName();
	void SetSzName(LPCTSTR lpszNewValue);
	CString GetSzKName();
	void SetSzKName(LPCTSTR lpszNewValue);
	CString GetSzSelectKbn();
	void SetSzSelectKbn(LPCTSTR lpszNewValue);
	CString GetSzExchangeCode();
	void SetSzExchangeCode(LPCTSTR lpszNewValue);
	CString GetSzICD10_1();
	void SetSzICD10_1(LPCTSTR lpszNewValue);
	CString GetSzICD10_2();
	void SetSzICD10_2(LPCTSTR lpszNewValue);
	CString GetSzICD10Precision();
	void SetSzICD10Precision(LPCTSTR lpszNewValue);
	CString GetSzICDCandidate();
	void SetSzICDCandidate(LPCTSTR lpszNewValue);
	CString GetSzReseName();
	void SetSzReseName(LPCTSTR lpszNewValue);
	CString GetSzResePrecision();
	void SetSzResePrecision(LPCTSTR lpszNewValue);
	CString GetSzResembleDiseaseCode();
	void SetSzResembleDiseaseCode(LPCTSTR lpszNewValue);
	CString GetSzConnectModifierKbnCode();
	void SetSzConnectModifierKbnCode(LPCTSTR lpszNewValue);
	CString GetSzCode();
	void SetSzCode(LPCTSTR lpszNewValue);
	CString GetSzModifierJumpInfo();
	void SetSzModifierJumpInfo(LPCTSTR lpszNewValue);
	CString GetSzReseCode();
	void SetSzReseCode(LPCTSTR lpszNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IModifierDetail bv NX

class IModifierDetail : public COleDispatchDriver
{
public:
	IModifierDetail() {}		// COleDispatchDriver ftHg RXgNV
	IModifierDetail(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IModifierDetail(const IModifierDetail& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetSzID();
	void SetSzID(LPCTSTR lpszNewValue);
	CString GetSzName();
	void SetSzName(LPCTSTR lpszNewValue);
	CString GetSzKName();
	void SetSzKName(LPCTSTR lpszNewValue);
	CString GetSzCode();
	void SetSzCode(LPCTSTR lpszNewValue);
	CString GetSzConnectPosKbn();
	void SetSzConnectPosKbn(LPCTSTR lpszNewValue);
	CString GetSzModifierKbn();
	void SetSzModifierKbn(LPCTSTR lpszNewValue);
	CString GetSzExcluSionCode();
	void SetSzExcluSionCode(LPCTSTR lpszNewValue);
	CString GetSzReseCode();
	void SetSzReseCode(LPCTSTR lpszNewValue);
	CString GetSzMasanCode();
	void SetSzMasanCode(LPCTSTR lpszNewValue);
	CString GetSzModifierComment();
	void SetSzModifierComment(LPCTSTR lpszNewValue);
};
/////////////////////////////////////////////////////////////////////////////
// IKeywordDetail bv NX

class IKeywordDetail : public COleDispatchDriver
{
public:
	IKeywordDetail() {}		// COleDispatchDriver ftHg RXgNV
	IKeywordDetail(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IKeywordDetail(const IKeywordDetail& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Agr[g
public:

// Iy[V
public:
	CString GetSzID();
	void SetSzID(LPCTSTR lpszNewValue);
	CString GetSzDMKbn();
	void SetSzDMKbn(LPCTSTR lpszNewValue);
	CString GetSzKNKbn();
	void SetSzKNKbn(LPCTSTR lpszNewValue);
	CString GetSzSynonymKbn();
	void SetSzSynonymKbn(LPCTSTR lpszNewValue);
	CString GetSzVariantKbn();
	void SetSzVariantKbn(LPCTSTR lpszNewValue);
	CString GetSz1stUsed();
	void SetSz1stUsed(LPCTSTR lpszNewValue);
	CString GetSzLangKbn();
	void SetSzLangKbn(LPCTSTR lpszNewValue);
	CString GetSzAbbrKbn();
	void SetSzAbbrKbn(LPCTSTR lpszNewValue);
};
