/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// uDlgDiseasetree.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uDlgDiseasetree.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseTreeView _CAO


CuDlgDiseaseTreeView::CuDlgDiseaseTreeView(CWnd* pParent /*=NULL*/)
	: CDialog(CuDlgDiseaseTreeView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CuDlgDiseaseTreeView)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	bMustExpand = FALSE;
}


void CuDlgDiseaseTreeView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuDlgDiseaseTreeView)
	DDX_Control(pDX, IDC_TREE_DISEASE, m_oTreeCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuDlgDiseaseTreeView, CDialog)
	//{{AFX_MSG_MAP(CuDlgDiseaseTreeView)
	ON_WM_SIZE()
	ON_NOTIFY(NM_CLICK, IDC_TREE_DISEASE, OnClickTreeDisease)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE_DISEASE, OnDblclkTreeDisease)
	ON_NOTIFY(TVN_KEYDOWN, IDC_TREE_DISEASE, OnKeydownTreeDisease)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_DISEASE, OnSelchangedTreeDisease)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseTreeView bZ[W nh
#include "DiseaseTreeSearchViewCtl.h"
void CuDlgDiseaseTreeView::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(((CDiseaseTreeSearchViewCtrl*)GetParent())->m_bAutoResize == TRUE)
	{
		if(m_oTreeCtrl.GetSafeHwnd() != NULL)
		{
			m_oTreeCtrl.MoveWindow(0,0,cx,cy);
			m_oTreeCtrl.Invalidate();
		}
	}	
}



void CuDlgDiseaseTreeView::uSetNewStyle(long lStyleMask, BOOL bSetBits)
{
	long style;
	style = GetWindowLong(this->m_oTreeCtrl.m_hWnd,GWL_STYLE);

	if(bSetBits)
	{
		style|= lStyleMask;
	}
	else
	{
		style &= ~lStyleMask;
	}
	SetWindowLong(this->m_oTreeCtrl.m_hWnd,GWL_STYLE,style);
	UpdateWindow();
	SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER);
}

void CuDlgDiseaseTreeView::OnClickTreeDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	//NbNꍇɁAucv{^ꂽAWJȂB
	bMustExpand = FALSE;
	UINT nHitFlags;
	HTREEITEM hItem = m_oTreeCtrl.HitTest(m_oTreeCtrl.m_Point,&nHitFlags);
	if (nHitFlags == TVHT_ONITEMBUTTON){
		bMustExpand = TRUE;
	}

	m_oTreeCtrl.m_hItem = hItem;
	((CDiseaseTreeSearchViewCtrl*)GetParent())->uClick();

	*pResult = 0;
}

void CuDlgDiseaseTreeView::OnDblclkTreeDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//_uNbNB
	((CDiseaseTreeSearchViewCtrl*)GetParent())->uDbClick();	
	*pResult = 0;
}

BOOL CuDlgDiseaseTreeView::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_oTreeCtrl.uSetFlag(DISEASETREE);		//aƏC敪
	((CDiseaseTreeSearchViewCtrl*)GetParent())->uSetTreeTop();

	return TRUE;
}

void CuDlgDiseaseTreeView::OnKeydownTreeDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_KEYDOWN* pTVKeyDown = (TV_KEYDOWN*)pNMHDR;

	//L[[h㉺L[̃ANV̂
	if (pTVKeyDown->wVKey == VK_LEFT || pTVKeyDown->wVKey == VK_RIGHT ){
		((CDiseaseTreeSearchViewCtrl*)GetParent())->SearchSonNode();	
	}

	*pResult = 0;
}

void CuDlgDiseaseTreeView::OnSelchangedTreeDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	m_oTreeCtrl.m_hItem=pNMTreeView->itemNew.hItem;
	((CDiseaseTreeSearchViewCtrl*)GetParent())->uSelectChanged();

	*pResult = 0;
}
