/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// uDlgModifierTreeSearchView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uDlgModifierTreeSearchView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "ModifierTreeSearchViewCtl.h"

/////////////////////////////////////////////////////////////////////////////
// CuDlgModifierTreeSearchView _CAO


CuDlgModifierTreeSearchView::CuDlgModifierTreeSearchView(CWnd* pParent /*=NULL*/)
	: CDialog(CuDlgModifierTreeSearchView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CuDlgModifierTreeSearchView)
	//}}AFX_DATA_INIT
}


void CuDlgModifierTreeSearchView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuDlgModifierTreeSearchView)
	DDX_Control(pDX, IDC_JUMP, m_StaticJump);
	DDX_Control(pDX, IDC_TREE_TREESEARCHVIEW, m_TreeView);
	DDX_Control(pDX, IDC_COMBO_TREESEARCHVIEW, m_ComboBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuDlgModifierTreeSearchView, CDialog)
	//{{AFX_MSG_MAP(CuDlgModifierTreeSearchView)
	ON_WM_SIZE()
	ON_CBN_SELCHANGE(IDC_COMBO_TREESEARCHVIEW, OnSelchangeComboTreesearchview)
	ON_NOTIFY(NM_CLICK, IDC_TREE_TREESEARCHVIEW, OnClickTreeTreesearchview)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE_TREESEARCHVIEW, OnDblclkTreeTreesearchview)
	ON_NOTIFY(TVN_KEYDOWN, IDC_TREE_TREESEARCHVIEW, OnKeydownTreeTreesearchview)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_TREESEARCHVIEW, OnSelchangedTreeTreesearchview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuDlgModifierTreeSearchView bZ[W nh

void CuDlgModifierTreeSearchView::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(((CModifierTreeSearchViewCtrl*)GetParent())->m_bAutoResize == TRUE)
	{
		if(m_ComboBox.GetSafeHwnd() != NULL &&	m_TreeView.GetSafeHwnd() != NULL)
		{
			CRect rect;
			m_ComboBox.GetWindowRect(&rect);
			m_TreeView.MoveWindow(0,rect.Height() + 15,cx,cy);
			m_TreeView.Invalidate();
		}
	}	

		
}

void CuDlgModifierTreeSearchView::uSetNewStyle(long nNewStyle, BOOL bFlag)
{
	long style;
	style = GetWindowLong(this->m_TreeView.m_hWnd,GWL_STYLE);

	if(bFlag)
	{
		style|= nNewStyle;
	}
	else
	{
		style &= ~nNewStyle;
	}
	SetWindowLong(this->m_TreeView.m_hWnd,GWL_STYLE,style);
	UpdateWindow();
	SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER);
}
                                        
void CuDlgModifierTreeSearchView::OnClickTreeTreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{ 
	//NbNꍇɁAucv{^ꂽAWJȂB
	m_bMustExpand = FALSE;
	UINT nHitFlags;
	HTREEITEM hTemp = m_TreeView.HitTest(m_TreeView.m_Point,&nHitFlags);
	if (nHitFlags == TVHT_ONITEMBUTTON){
		m_bMustExpand = TRUE;
	}

	m_TreeView.m_hItem = hTemp;
	((CModifierTreeSearchViewCtrl*)GetParent())->uTreeViewClick();

	*pResult = 0;

}

void CuDlgModifierTreeSearchView::OnDblclkTreeTreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	((CModifierTreeSearchViewCtrl *)GetParent())->uTreeViewDbClick();
	*pResult = 0;				
}

void CuDlgModifierTreeSearchView::OnSelchangeComboTreesearchview() 
{
	((CModifierTreeSearchViewCtrl *)GetParent())->uComboChange();
}

BOOL CuDlgModifierTreeSearchView::OnInitDialog() 
{
	CDialog::OnInitDialog();

    ((CModifierTreeSearchViewCtrl *)GetParent())->uSetTreeTop();
	m_TreeView.uSetFlag(MODIFYTREE);	//aƏC敪

	return TRUE;
}

void CuDlgModifierTreeSearchView::OnKeydownTreeTreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_KEYDOWN* pTVKeyDown = (TV_KEYDOWN*)pNMHDR;

	if (pTVKeyDown->wVKey == VK_LEFT || pTVKeyDown->wVKey == VK_RIGHT ){
		((CModifierTreeSearchViewCtrl *)GetParent())->SearchSonNode();	
	}

	*pResult = 0;
}

void CuDlgModifierTreeSearchView::OnSelchangedTreeTreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	m_TreeView.m_hItem = m_TreeView.GetSelectedItem();
	((CModifierTreeSearchViewCtrl *)GetParent())->uSelectChanged();

	*pResult = 0;
}
