/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// uDlgPartView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uDlgPartView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuDlgPartModifyView _CAO


CuDlgPartModifyView::CuDlgPartModifyView(CWnd* pParent /*=NULL*/)
	: CDialog(CuDlgPartModifyView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CuDlgPartModifyView)
	//}}AFX_DATA_INIT
}


void CuDlgPartModifyView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuDlgPartModifyView)
	DDX_Control(pDX, IDC_STA_IMAGE, m_oImage);
	DDX_Control(pDX, IDC_LIST_VIEW, m_oListView);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuDlgPartModifyView, CDialog)
	//{{AFX_MSG_MAP(CuDlgPartModifyView)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_VIEW, OnDblclkListView)
	ON_NOTIFY(NM_CLICK, IDC_LIST_VIEW, OnClickListView)
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
#include "PartModifierSearchViewCtl.h"


void CuDlgPartModifyView::uModifyStyle(DWORD dStyle, BOOL bsetbit)
{
	if(bsetbit)
		m_oListView.ModifyStyle(0L,dStyle);
	else
		m_oListView.ModifyStyle(dStyle,0L);
}

void CuDlgPartModifyView::uSetNewStyle(long lStyleMask, BOOL bSetBits)
{
	DWORD  dwStyle = ListView_GetExtendedListViewStyle(this->m_oListView.m_hWnd);
	if(bSetBits)
	{
		dwStyle |= lStyleMask;
		ListView_SetExtendedListViewStyle(this->m_oListView.m_hWnd,dwStyle);
	}
	else
	{	
		dwStyle &= ~lStyleMask;
		ListView_SetExtendedListViewStyle(this->m_oListView.m_hWnd,dwStyle);
	}
}

void CuDlgPartModifyView::uAddHeadColumn()
{
	LVCOLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH ;
	lvc.fmt = LVCFMT_CENTER ;
	lvc.cx = 186;
	lvc.pszText = "C";
	lvc.cchTextMax = 186;
	m_oListView.InsertColumn(0,&lvc);
}

BOOL CuDlgPartModifyView::OnInitDialog() 
{
	CDialog::OnInitDialog();
	uAddHeadColumn();
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CuDlgPartModifyView::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(((CPartModifierSearchViewCtrl*)GetParent())->m_bAutoResize == TRUE)
	{
		if((m_oListView.GetSafeHwnd() != NULL) && (m_oImage.GetSafeHwnd() != NULL))
		{
			int nMonopolize = ((CPartModifierSearchViewCtrl*)GetParent())->m_nMonopolize;
			int m_nImageWidth = cx * nMonopolize / 100;
			m_oImage.MoveWindow(0,0,m_nImageWidth,cy);		
			m_oListView.MoveWindow(m_nImageWidth,0,cx - m_nImageWidth,cy);
			m_oImage.Invalidate();
			m_oListView.Invalidate();
		}
	}	
}

void CuDlgPartModifyView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRect rectImage;
	m_oImage.GetClientRect(rectImage);
	if (rectImage.PtInRect(point))
	{
		((CPartModifierSearchViewCtrl*)GetParent())->uImageClick(point);
		((CPartModifierSearchViewCtrl*)GetParent())->uImageMouseClick(nFlags,point);
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CuDlgPartModifyView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CRect rectImage;
	m_oImage.GetClientRect(rectImage);

	if (rectImage.PtInRect(point))
		((CPartModifierSearchViewCtrl*)GetParent())->uImageDbClick();
	CDialog::OnLButtonDblClk(nFlags, point);
}

void CuDlgPartModifyView::OnDblclkListView(NMHDR* pNMHDR, LRESULT* pResult) 
{
	((CPartModifierSearchViewCtrl*)GetParent())->uListViewDbClick();
	*pResult = 0;
}


void CuDlgPartModifyView::OnClickListView(NMHDR* pNMHDR, LRESULT* pResult) 
{
	((CPartModifierSearchViewCtrl*)GetParent())->uListViewClick(pNMHDR);
	*pResult = 0;
}



void CuDlgPartModifyView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CRect rectImage;
	m_oImage.GetClientRect(rectImage);
	if (rectImage.PtInRect(point))
	{
		((CPartModifierSearchViewCtrl*)GetParent())->uImageMouseClick(nFlags,point);
	}	
	CDialog::OnRButtonDown(nFlags, point);
}

void CuDlgPartModifyView::OnMButtonDown(UINT nFlags, CPoint point) 
{
	CRect rectImage;
	m_oImage.GetClientRect(rectImage);
	if (rectImage.PtInRect(point))
	{
		((CPartModifierSearchViewCtrl*)GetParent())->uImageMouseClick(nFlags,point);
	}		
	CDialog::OnMButtonDown(nFlags, point);
}
