/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// uMyComboBox.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uMyComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuMyComboBox

CuMyComboBox::CuMyComboBox()
{
	 m_crForeColor = RGB(0,0,0);
	 m_crBackColor = RGB(0,0,0);
}

CuMyComboBox::~CuMyComboBox()
{
}


BEGIN_MESSAGE_MAP(CuMyComboBox, CComboBox)
	//{{AFX_MSG_MAP(CuMyComboBox)
	ON_CONTROL_REFLECT(CBN_DROPDOWN, OnDropdown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuMyComboBox bZ[W nh



void CuMyComboBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	
	static		CString	sColor(_T(""));								// No Need To Reallocate Each Time

	CDC			dcContext;
	CRect		rItemRect( lpDrawItemStruct -> rcItem );

	int			iItem = lpDrawItemStruct -> itemID;
	int			iAction = lpDrawItemStruct -> itemAction;
	int			iState = lpDrawItemStruct -> itemState;
	
	COLORREF	crColor = 0;
	COLORREF	crNormal = GetSysColor( COLOR_WINDOW );
	COLORREF	crSelected = GetSysColor( COLOR_HIGHLIGHT );
	COLORREF	crText = GetSysColor( COLOR_WINDOWTEXT );

	if( !dcContext.Attach( lpDrawItemStruct -> hDC ) )				
			return;	

		if( iState & ODS_SELECTED )								
		{														
			dcContext.SetTextColor(
					( 0x00FFFFFF & ~( crText ) ) );				
			dcContext.SetBkColor( crSelected );				
			dcContext.FillSolidRect( &rItemRect, crSelected );
		}
		else													
		{														
			dcContext.SetTextColor( m_crBackColor );					
			dcContext.SetBkColor( m_crForeColor);					
			dcContext.FillSolidRect( &rItemRect, m_crForeColor);	
		}
		if( iState & ODS_FOCUS )								
			dcContext.DrawFocusRect( &rItemRect );				
		if( iItem != -1 )										
		{
			GetLBText( iItem, sColor );
			CSize tempSize = dcContext.GetTextExtent(sColor);
            
			if( iState & ODS_DISABLED )							
			{
				crColor = GetSysColor( COLOR_INACTIVECAPTIONTEXT );
				dcContext.SetTextColor( crColor );				
			}
			else
			{													
				dcContext.SetBkMode( TRANSPARENT );	
				dcContext.TextOut( rItemRect.left + 2, rItemRect.top +2,
						sColor );
			}
		}
	dcContext.Detach();
}

void CuMyComboBox::uSetBKColor(COLORREF crBKColor)
{
	m_crBackColor = crBKColor;
}

void CuMyComboBox::uSetForeColor(COLORREF crForeColor)
{
	m_crForeColor = crForeColor;
}




void CuMyComboBox::OnDropdown() 
{
	RecalcDropWidth();
}

void CuMyComboBox::RecalcDropWidth()
{
    int nNumEntries = GetCount();
    int nWidth = 0;
    CString str;

    CClientDC dc(this);
    int nSave = dc.SaveDC();
    dc.SelectObject(GetFont());

    int nScrollWidth = ::GetSystemMetrics(SM_CXVSCROLL);
    for (int i = 0; i < nNumEntries; i++)
    {
        GetLBText(i, str);
        int nLength = dc.GetTextExtent(str).cx + nScrollWidth;
        nWidth = max(nWidth, nLength);
    }

    // Add margin space to the calculations
    nWidth += dc.GetTextExtent("0").cx;

    dc.RestoreDC(nSave);
    SetDroppedWidth(nWidth);

}
