/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

#include "stdafx.h"
#include "common.h"
#include "Log.h"

//`
int MakeStrTbl(char *pStrData,char **pStrTable,int nWordCnt,int nWordLen,char cCutSign)
{
 	int nRet = RETOK;

	char *pSPos = NULL,*pEPos = NULL;

	if (IsStrEmpty(pStrData))                           //|CgNULLAG[
	{
		nRet = RETERR;
	}

	if (nRet == RETOK)                         //Wuwe𓾂D
	{
		pSPos = pStrData;
		for (int i = 0; i < nWordCnt ;i++)
		{
			if (*pSPos == '\0') 
			{
				break;
			}
			if (*pSPos == cCutSign)
			{
				i--;
				pSPos++;
				continue;
			}

			// -------------------------------------------
			pEPos = strchr(pSPos,cCutSign);
			if (pEPos != NULL) {
				if (pEPos-pSPos <= nWordLen) {
					strncpy(pStrTable[i],pSPos,(pEPos-pSPos));
				}
				else {
					nRet = RETERR;
					break;
				}
				pSPos = ++pEPos; 
			}
			else {
				if ((int)strlen(pSPos) <= nWordLen) {
					strcpy(pStrTable[i],pSPos);
				}
				else {
					nRet = RETERR;
					break;
				}
				break;
			}
		}
	}

	return nRet;
}

int IsStrEmpty(char* pszString)
{
	int nRet = RETOK;
	char* szStrBuf = NULL;

	if (pszString == NULL) 
	{
		nRet = RETERR;
		return nRet;
	}
	if (pszString[0] == '\0') 
	{
		nRet = RETERR;
		return nRet;
	}

	/*Ɠ̃Xy[X쐬*/
	szStrBuf = (char*)malloc(sizeof(char)*(strlen(pszString)+1));
	strcpy(szStrBuf,pszString);
	strset(szStrBuf,0x20);
	
	/*Xy[X`FbN*/
	if (strcmp(pszString,szStrBuf) == 0) 
	{
		nRet = RETERR;
	}
	
	free(szStrBuf);
	return nRet;
}

/*int GetStrCnt(char *pStrData, char cCutSign)
{
	int nCnt = 0;

	if (pStrData == NULL || pStrData == "")							//|CgNULLAG[
	{
		return nCnt;
	}

	//؂蕄̐擾
	for (int i = 0; i < (int)strlen(pStrData);i++) {
		//̋ؕ̓Wuwf[^Ɏw肵Ă
//		if (pStrData[i] == cCutSign) {
//			nCnt++;
//		}
		if(i>0){
			if (pStrData[i] == cCutSign &&
				pStrData[i-1] !='\\') {
				nCnt++;
			}
		}
		else if (pStrData[i] == cCutSign){
			nCnt++;
		}
	}

	return nCnt;

}*/

void WriteLogMessage(char *pszPath,XCLOGH hLog,char *pszMsgID)
{
	// G[Oo
	char	szLogMsg[256] = {""};
	//n郁bZ[WIDƑ΂郁bZ[We擾
	char szFullPath[_MAX_PATH]={""};
	sprintf(szFullPath,"%s\\%s",pszPath,MSGFILE);
	if (MsgFormatGet(hLog,pszMsgID,szFullPath,szLogMsg) == RETOK) 
	{
		//擾үޓeOt@Cɏ
		XcLogWrite(hLog,pszMsgID,szLogMsg);
	}

}

void WriteLogMessage(char *pszPath,XCLOGH hLog,char *pszMsgID,char *pszMsgTxt)
{
	// G[Oo
	char	szLogMsg[256] = {""};
	char    szlogTemp[256] ={""};
	//n郁bZ[WIDƑ΂郁bZ[We擾
	char szFullPath[_MAX_PATH]={""};
	sprintf(szFullPath,"%s\\%s",pszPath,MSGFILE);
	if (MsgFormatGet(hLog,pszMsgID,szFullPath,szlogTemp) == RETOK) 
	{
		//擾үޓeOt@Cɏ
		sprintf(szLogMsg,szlogTemp,pszMsgTxt);
		XcLogWrite(hLog,pszMsgID,szLogMsg);
	}

}
int MsgFormatGet(XCLOGH hLog,char *pszMsgID,
				 const char *pszMsgFile,char *pszMsg)
{
	// G[Oo
	int nRet = RETOK;
	if (hLog != NULL && !IsStrEmpty(pszMsgID)) 
	{
		char	szPathNm[_MAX_PATH] = {""};
		char	szFileNm[_MAX_PATH] = {""};
		char	szLogMsg[256]	= {""};
		////////////////V􂪍XV 6.28////////////				
		//үIDƑ΂үޓe擾
		switch (ReadIniValue("Message",pszMsgID,szLogMsg,256,(char*)pszMsgFile)) 
		{
		case RETOK:
			memset(pszMsg,'\0',sizeof(pszMsg));
			strcpy(pszMsg,szLogMsg);
			nRet = RETOK;
			break;
		case RETERR:
			//Yt@CȂ΁AOo͂
			strcpy(szLogMsg,NOMSGFILE);
			XcLogWrite(hLog,pszMsgID,szLogMsg);
			memset(pszMsg,'\0',sizeof(pszMsg));
			strcpy(pszMsg,szLogMsg);				
			nRet = RETERR;
			break;
		default:

			nRet = RETERR;
			break;
		}
	}

	return nRet;
}

int ReadIniValue(char *szSection, char *szKey, 
				 char *szGetValue, int nSize, char *szFileName)
{
	int nRet = RETOK;
	// NULL`FbN
	if ((szKey == NULL) || (szSection == NULL) || (szFileName == NULL))
	{
		return RETERR;
	}
	else{
		//Oo̓bZ[W`t@C𑶍݃`FbN
		if (::GetFileAttributes(szFileName) == 0xFFFFFFFF) {
			//̃t@CȂ
			return RETERR;
		}

		// Oo̓bZ[W擾
		if (::GetPrivateProfileString(szSection, szKey, "???????", 
				szGetValue, nSize, szFileName) > 0) {
			if (strcmp(szGetValue,"???????") == 0) 
			{ 
				//n郁bZ[WID`ĂȂ
				strset(szGetValue,'\0');
				nRet = RETERR;
			}
			else {
				//OKԂ
				nRet = RETOK;
			}
		}
		else {
			//n郁bZ[WIDɑ΂郁bZ[W
			nRet = RETERR;
		}
	}

	return nRet;
}

int GetStrCnt(CString strData, char cCutSign)
{
	int nCount=0;

	int nPos=0;
	while((nPos=strData.Find(cCutSign))>-1)
	{
		nCount++;
		if(nPos+1<strData.GetLength()){
			strData=strData.Mid(nPos+1);
		}
		else{
			break;
		}
	}

	return nCount;
}

void WriteLogMessage(char *pszPath,XCLOGH hLog,char *pszMsgID,char *pszMsgTxt,int nValue)
{
	// G[Oo
	char	szLogMsg[256] = {""};
	char    szlogTemp[256] ={""};
	//n郁bZ[WIDƑ΂郁bZ[We擾
	char szFullPath[_MAX_PATH]={""};
	sprintf(szFullPath,"%s\\%s",pszPath,MSGFILE);
	if (MsgFormatGet(hLog,pszMsgID,szFullPath,szlogTemp) == RETOK) 
	{
		//擾үޓeOt@Cɏ
		sprintf(szLogMsg,szlogTemp,pszMsgTxt,nValue);
		XcLogWrite(hLog,pszMsgID,szLogMsg);
	}
}