/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

#ifndef _CSVDATA_H_
#define _CSVDATA_H_

#include "define.h"
#include "binarydata.h"

/***************************************************************
	. a{}X^t@C(CSV)̃f[^\
****************************************************************/

/***************************************
	1. a{e[u\
***************************************/
/*
a{e[ũtB[h\
*/
typedef struct {
	int  nInvalidityKbn;						/*敪 */
	char szNameNo[DIS_NUM+1];					/*a\Lԍ */
	char szName[DIS_NAME+1];					/*a\L*/
	char szKName[DIS_KNAME+1];					/*a\LJi*/
	char szSelectKbn[DIS_SELKBN+1];				/*̑敪*/
	char szExchangeCode[DIS_EXCODE+1];			/*apR[h*/
	char szICD10_1[DIS_ICD101+1];    			/*vC}ICDPOR[h*/
	char szICD10_2[DIS_ICD102+1];				/*dރR[h*/
	char szICD10Precision[DIS_ICD10PREC+1];		/*ICD10-1tB[h̒l̊mx*/
	char szICDCandidate[DIS_ICD10CAND+1];		/*ICD10mx*/
	char szReseCode[DIS_RESECODE];				/*ZdZR[h*/
	char szReseName[DIS_NAME+1];				/*ZdZΉ\L*/
	char szResePrecision[DIS_RESEPREC+1];		/*ZdZΉmx*/
	char szUpdateHistoryCode[UPDATENUM+1];	   	/*XVԍ*/
	char szUpdateDate[UPDATEDATE+1];		    /*XVt*/
	char szManageCode[MANAGECODE+1];		    /*ڍsǗԍ*/
} DISEASE_BASIC_FILE;

/***************************************
	2. a⏕f[u\
***************************************/
/*
a⏕f[ũtB[h\
*/
typedef struct {
	int  nInvalidityKbn;							/*敪 */
	char szSubNo[DIS_SUBNUM+1];					/*a⏕R[hǗԍ */
	char szNameNo[DIS_NUM+1];						/*a\Lԍ */
	char szName[DIS_NAME+1];						/*a\L*/
	char szResCode[DIS_RESCODE+1];		/*ގaR[h*/
	char szConnModKbnCode[DIS_CONNMODKBN+1];/*ڑC敪R[h*/
	char szNorCode[DIS_NORCODE+1];						/*aR[hK*/
    char szSynInfo[DIS_SYNINFO+1];					/*a`\L*/
    char szModID[MOD_ID+1];				/*CKwڃN*/

} DISEASE_SUB_FILE;

/***************************************
	3. L[E[hf[u\
***************************************/
/*
L[E[hf[ũtB[h\
*/
typedef struct {
	char szKeyWord[KEY_WORD+1];				/*L[E[h */
	char szEquCode[DIS_EXCODE+1];			/*ΉpR[h*/
	char szDisModKbn[KEY_DMKBN+1];			/*aC敪*/
	char szKNKbn[KEY_KNKBN+1];				/*Ȋ敪*/
	char szSynKbn[KEY_SYNKBN+1];			/*`敪*/
	char szVarKbn[KEY_VARKBN+1];			/*َ̋敪*/
	char szNo1Kbn[KEY_NO1KBN+1];			/*Pō̗p\L敪*/
	char szLangKbn[KEY_LANGKBN+1]; 			/*敪ip\j*/
	char szAbbrKbn[KEY_ABBRKBN+1];	  	    /*ȗ敪ip\j*/

} KEYWORD_FILE;

/***************************************
	4. C{f[u\
***************************************/
/*
C{f[ũtB[h\
*/
typedef struct {
	int  nInvalidityKbn;					/*敪 */
	char szBasicNo[MOD_NUM+1];				/*CǗԍ */
	char szName[MOD_NAME+1];       			/*C\L*/
	char szKName[MOD_KNAME+1];				/*C\LJi*/
	char szCode[MOD_CODE+1];				/*CR[h*/
	char szConPosKbn[MOD_CONNPOS+1];		/*ڑʒu敪*/
	char szKbn[MOD_KBN+1];					/*C敪*/
	char szGroupCode[MOD_EXCLCODE+1];		/*rO[vR[h*/
	char szReseCode[MOD_RESECODE+1]; 		/*ZdZCR[h*/
	char szExplanation[MOD_COMMENT+1];		/*Cpx*/

} MODIFIER_BASIC_FILE;

/***************************************
	5. C⏕f[u\
***************************************/
/*
C⏕f[ũtB[h\
*/
typedef struct {
	int  nInvalidityKbn;				/*敪 */
	char szSubNo[MOD_SUBNUM+1];		/*C⏕R[hǗԍ */
	char szBasicNo[MOD_NUM+1];			/*CǗԍ */
	char szName[MOD_NAME+1];			/*C\L*/
	char szNorCode[MOD_NORCODE+1];		/*CR[hK*/
    char szSynInfo[MOD_SYNINFO+1];		/*Cꓯ`\L*/

} MODIFIER_SUB_FILE;

/***************************************
	6. PŗpΉe[u\
***************************************/
/*
PŗpΉe[ũtB[h\
*/
typedef struct {
	int  nInvalidityKbn;						/*敪 */
	char szNo1Code[NO1_NUM+1];			   	    /*łł̊Ǘԍ */
	char szNo1NameCode[NO1_CODE+1];	            /*łł̕aR[h*/
    char szNo1Name[NO1_NAME+1];					/*ŕa\L*/
	char szNo1KName[NO1_KNAME+1];				/*ŕa\LJi*/
	char szNo2EquCode[NO2_CODE+1];		   	    /*őΉR[h */
	char szNo2AccuracyCode[NO2_PREC+1];		    /*őΉmx */
    char szNo2Name[NO2_NAME+1];					/*ŕa\L*/

} EQUIVALENCE_FILE;

/***************************************
	7. aKwڃe[u\
***************************************/
/*
aKwڃe[ũtB[h\
*/
typedef struct {
	char szItemID[DIS_NUM+1];			   	/*KwID*/
	char szItemName[DIS_NAME+1];	            /*Kwږ*/
} DISEASE_ITEM_FILE;

/***************************************
	8. aKwڊ֌We[u\
***************************************/
/*
aKwڊ֌We[ũtB[h\
*/
typedef struct {
//	char szItemID[DIS_NUM+1];			    /*KwID*/
//	char szTopItemID[DIS_NUM+1];			   	/*ʊKwID*/
//	char szDivision[DIS_TREEKBN+1];		    /*Kwڋ敪*/
//	char szTopDivision[DIS_TREEKBN+1];		/*ʍڋ敪*/

	char szDisID[DIS_ID+1];					/*KwID*/
	char szTopDisID[DIS_ID+1];				/*ʊKwID*/
	char szExpOrder[DIS_ORDER+1];			/*\*/

} DISEASE_TREE_FILE;

/***************************************
	9. CKwڃe[u\
***************************************/
/*
CKwڃe[ũtB[h\
*/
typedef struct {
	char szItemID[MOD_NUM+1];			   	/*KwID*/
	char szItemName[MOD_NAME+1];	            /*Kwږ*/
} MODIFIER_ITEM_FILE;


/***************************************
	10. CKwڊ֌We[u\
***************************************/
/*
CKwڊ֌We[ũtB[h\
*/
typedef struct {
	//char szItemID[MOD_NUM+1];			    /*KwID*/
	//char szTopItemID[MOD_NUM+1];			   	/*ʊKwID*/
	//char szDivision[MOD_TREEKBN+1];	     	/*Kwڋ敪*/
	//char szTopDivision[MOD_TREEKBN+1];		/*ʍڋ敪*/
	char szModID[MOD_ID+1];                   /*KwID*/
	char szTopModID[MOD_ID+1];                /*ʊKwID*/
	char szExpOrder[MOD_ORDER+1];			/*\*/
} MODIFIER_TREE_FILE;

/***************************************
	11. C敪̃e[u\
***************************************/
/*
C敪̃f[u\
*/
typedef struct {
	char szDivisionID[MOD_KBN+1];			   	/*C敪ID*/
	char szDivisionIDName[MOD_KNAME+1];	        /*敪*/
} MODIFIER_DIVISION_FILE;

/***************************************************************
	. e|\̃f[^
****************************************************************/

/***************************************
	1. L[[hIndexe|\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	KEYWORDINDEX oKeyIndex;				/* L[[hIndext@ĈׂătB[h*/
	CPtrArray  oKeyWordDisDetail;    	/* aL[[hڍ׃Xgւ̃|C^ */
	CPtrArray  oKeyWordModDetail;   	/* CL[[hڍ׃Xgւ̃|C^ */
	long nDiseaseOffset;		        /* aʒu*/
	int  nDiseaseCounter;			  	/* a*/
	long nModifierOffset;				/* Cʒu*/
	int  nModifierCounter;				/* C*/

} KEYWORDINDEX_TEMP;

/***************************************
	2. CIndexe|\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	MODIFIERINDEX oModifierIndex;				/* CIndext@ĈׂătB[h*/
	MODIFIERDETAIL_TEMP *pModifierDetailTemp;	/* Cڍ׃e|ւ̃|C^   */
	void *pFather;				   				/* _ւ̃|C^*/
	CArray<void*,void*> arrSon;					/* q_ւ̃|C^Xg*/ 
	//2002.05.10 by 
	BOOL bDisabled;								/* YaWJꂽtO*/
} MODIFIERINDEX_TEMP;

/***************************************
	3. ގae|\
***************************************/
/*
ގat@C̃tB[h\
*/
typedef struct {
	CStringArray oResembleDisease;				/* ގaID̃Xg*/
	long nResembleDiseaseOffset;		        /* ގaʒu*/
	int  nResembleDiseaseCounter;			  	/* ގa*/

} RESEMBLEDISEASE_TEMP;

/***************************************
	4. aIndexe|\
***************************************/
/*
aIndext@C̃tB[h\
*/
typedef struct {
	DISEASEINDEX oDiseaseIndex;						/* aIndext@ĈׂătB[h*/
	DISEASEDETAIL_TEMP *pDiseaseDetailTemp;			/* aڍ׃e|ւ̃|C^   */
	RESEMBLEDISEASE_TEMP  *pResembleDiseaseTemp;  	/* ގae|ւ̃|C^*/
	void *pFather;				   					/* _ւ̃|C^*/
	CArray<void*,void*> arrSon;						/* q_ւ̃|C^Xg*/ 
	//2002.05.10 by 
	BOOL bDisabled;									/* YaWJꂽtO*/
} DISEASEINDEX_TEMP;

#endif
