Attribute VB_Name = "frmFXISExpansion"
'/***************************************************************************
'*                                                                          *
'* Copyright (C) 2001-2002 wwa@Ï񕔁A              *
'*                         xm[bNX񊔎  BSƕ               *
'*                                                                          *
'***************************************************************************/

Option Explicit

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Type FileInformation
    FileVersion As String
    DiseaseBasicFile As String
    DiseaseSubFile As String
    DiseaseItemFile As String
    DiseaseTreeFile As String
    ModifierBasicFile As String
    ModifierSubFile As String
    ModifierItemFile As String
    ModifierTreeFile As String
    ModifierKbnFile As String
    KeywordFile As String
    OutFolder As String
End Type

Public g_FileInfo As FileInformation
Public Const RETOK = 0
Public Const RETERR = 1
Public Const RECFILE = "disEXPANDER.rec"
Public Const MSGFILE = "disEXPANDER.msg"

Private nRet As Integer


Public Function ShowMsg(ByVal strMsgVar As String, ByVal strMsgID As String) As Integer

    ShowMsg = RETOK
    
    'NULL`FbN
    If strMsgID = "" Then
        ShowMsg = RETERR
        Exit Function
    End If

    Dim nRet As Integer
    Dim strMsgValue As String * 256
    strMsgValue = Space$(256)
    nRet = GetMessage(strMsgID, App.Path & "\" & MSGFILE, strMsgValue)
    If nRet <> RETOK Then
        ShowMsg = RETERR
        Exit Function
    End If

    MsgBox strMsgVar & strMsgValue, vbOKOnly, "WJ°(disEXPANDER)"
End Function

Public Function GetMessage(ByVal strMsgID As String, ByVal strFileName, ByRef strMsgValue As String) As Integer

    On Error GoTo ERRPOS
    GetMessage = RETOK
    'NULL`FbN
    If strMsgID = "" Or strFileName = "" Then
        GetMessage = RETERR
        Exit Function
    End If

    'bZ[Wt@C݂邩`FbN
    Dim strTemp As String
    If Dir$(strFileName) = "" Then
        GetMessage = RETERR
        Exit Function
    End If
    
    'Oo̓bZ[W擾
    nRet = GetPrivateProfileString("Message", strMsgID, "???", strMsgValue, Len(strMsgValue), strFileName)
    If nRet = 0 Then
        GetMessage = RETERR
        Exit Function
    End If
    If Trim$(strMsgValue) = "???" Then
        GetMessage = RETERR
        Exit Function
    End If
    
    Exit Function
    
ERRPOS:
    GetMessage = RETERR
End Function

Public Function CreateDiretory(strPath As String) As Boolean

    On Error GoTo ERRPOS
    
    Dim strSubPath As String
    Dim nPos As Integer
    CreateDiretory = True
    
    'fBXNCu݂邩`FbN
    nPos = InStr(1, strPath, "\")
    If nPos > 0 Then
        strSubPath = Left(strPath, nPos)
        If Dir(strSubPath, vbDirectory) = "" Then
            'fBXNײނ݂Ȃ
            CreateDiretory = False
            Exit Function
        End If
    Else
        CreateDiretory = False
        Exit Function
    End If
 
    'fBNg쐬
    Do
        nPos = InStr(nPos + 1, strPath, "\")
        If nPos > 0 Then
            strSubPath = Left(strPath, nPos - 1)
            'fBNg݂ȂꍇAIɍ쐬
            If Dir(strSubPath, vbDirectory) = "" Then
               MkDir strSubPath
            End If
        Else
            'fBNg݂ȂꍇAIɍ쐬
            If Dir(strPath, vbDirectory) = "" Then
               MkDir strPath
            End If
            Exit Do
        End If
    Loop
    CreateDiretory = True
    
    Exit Function
    
ERRPOS:
    CreateDiretory = False
End Function


Public Function ReadFileInfo(ByVal strFilePath, ByVal strkey As String, ByRef strValue As String) As Integer

    On Error GoTo ERRPOS
    '
    ReadFileInfo = RETOK
    strValue = ""
    
    'NULL`FbN
    If strFilePath = "" Or strkey = "" Then
        ReadFileInfo = RETERR
        Exit Function
    End If
  
    'i[t@C݂邩`FbN
    Dim strTemp As String
    If Dir$(strFilePath) = "" Then
        ReadFileInfo = RETOK
        Exit Function
    End If

    Dim strFileName As String * 256
    strFileName = Space$(256)

    'OɎgpꂽt@CO擾
    nRet = GetPrivateProfileString("FileInfo", strkey, "", strFileName, Len(strFileName), strFilePath)
    If nRet = 0 Then
        ReadFileInfo = RETOK        '擾͎sĂÂ܂ܖ߂?
        Exit Function
    Else
        strValue = strFileName
    End If
    
    If Trim$(strValue) = "" Then
        ReadFileInfo = RETOK
        Exit Function
    End If
    Exit Function
ERRPOS:
    ReadFileInfo = RETERR
End Function

Public Function WriteFileInfo(ByVal strFilePath, ByVal strkey As String, ByVal strValue As String) As Integer

    On Error GoTo ERRPOS
    
    WriteFileInfo = RETOK

    'NULL`FbN
    If strFilePath = "" Or strkey = "" Then
        WriteFileInfo = RETERR
        Exit Function
    End If
  
    'i[t@C݂邩`FbN
    Dim strTemp As String
    If Dir$(strFilePath) = "" Then
        WriteFileInfo = RETERR
        Exit Function
    End If

'    'ZbV쐬
'    nRet = WritePrivateProfileSection("FileInfo", "", strFilePath)
'    If nRet = 0 Then
'        WriteFileInfo = RETERR
'        Exit Function
'    End If

    'ɎgpCSVt@Cۑ
    nRet = WritePrivateProfileString("FileInfo", strkey, strValue, strFilePath)
    If nRet = 0 Then
        WriteFileInfo = RETERR
        Exit Function
    End If
    Exit Function
ERRPOS:
    WriteFileInfo = RETERR
End Function

Public Function CreateFile(ByVal strFileFullPath) As Integer

    On Error GoTo ERRPOS
    
    CreateFile = RETOK

    'NULL`FbN
    If strFileFullPath = "" Then
        CreateFile = RETERR
        Exit Function
    End If

    'i[t@C݂邩`FbN
    Dim strTemp As String
    If Dir$(strFileFullPath) <> "" Then
        Exit Function
    End If

    'rect@CVKō쐬
    Open strFileFullPath For Output As #1
    Close #1
    
ERRPOS:
    CreateFile = RETERR
End Function
