/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// FXISMedicalControl.cpp : CFXISMedicalControlApp NX̃Cve[V DLL ̓o^s܂B

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "common.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CTypedPtrList <CPtrList,StructResultDiseaseNode *> m_oStructItemList;
CTypedPtrList <CPtrList,StructResultModifierNode*> m_StructResultModifierNodeList;


CFXISMedicalControlApp NEAR theApp;

const GUID CDECL BASED_CODE _tlid =
		{ 0x8e92f556, 0xfe5d, 0x4419, { 0x85, 0x4, 0xb4, 0xaf, 0xa3, 0x1b, 0xb9, 0xf0 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;


////////////////////////////////////////////////////////////////////////////
// CFXISMedicalControlApp::InitInstance - DLL ̏

BOOL CFXISMedicalControlApp::InitInstance()
{
	BOOL bInit = COleControlModule::InitInstance();
	return bInit;
}


////////////////////////////////////////////////////////////////////////////
// CFXISMedicalControlApp::ExitInstance - DLL ̏I

int CFXISMedicalControlApp::ExitInstance()
{
	// TODO: ̈ʒuɃW[̏IǉĂB

	return COleControlModule::ExitInstance();
}


/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - VXe WXg̃Ggǉ

STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid))
		return ResultFromScode(SELFREG_E_TYPELIB);

	if (!COleObjectFactoryEx::UpdateRegistryAll(TRUE))
		return ResultFromScode(SELFREG_E_CLASS);

	return NOERROR;
}


/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - VXe WXg̃Gg폜

STDAPI DllUnregisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor))
		return ResultFromScode(SELFREG_E_TYPELIB);

	if (!COleObjectFactoryEx::UpdateRegistryAll(FALSE))
		return ResultFromScode(SELFREG_E_CLASS);

	return NOERROR;
}

/******************************************************************
	Title		:	a/CpXϊ
	Function	:	ConvertDiseasePath() 
	Parameters	:	CString strPathID		a/CpX
					int nConvertType		ϊe[vF1DapX
														2DCpX		
					IBasicDBAccessPtr m_oBasicDBAccessPtr
											a{DBANZX̃IuWFNg
					CString& strPathName	ϊa/CpX
	Return		:	int		RETERR	:NG
							RETOK	:OK
	Description	:	a/CpXϊ
					\\ID1\\ID2\\ID3 ==>\\\L1\\\L2\\\L3
	Create By	:	b@@2000.05.24
******************************************************************/

int uConvertDiseasePath(CString strPathID,int nConvertType,
						IBasicDBAccessPtr m_oBasicDBAccessPtr,CString 
						&strPathName,long &lErrCode)
{
	DISEASEDETAIL oStructDiseaseDetail;
	MODIFIERDETAIL oStructModifierDetail;
	CString strPath(_T(""));
	CString strSubPath(_T(""));
	CString strID(_T(""));


	strPath = strPathID;
	strSubPath = strPathID;
	//pX`FbN
	int iLength = strPath.GetLength();
	if (iLength == 0)
		return RETERR;

	int iOldPos = 0;
	int iNewPos = 0;
	CString strTemp(_T(""));
	while (iNewPos != -1)
	{
		iNewPos = strPath.Find("\\",iNewPos + 1);
		if (iNewPos >= 0 )
			strID = strPath.Mid(iOldPos + 1,iNewPos - iOldPos - 1);
		else
			strID = strPath.Mid(iOldPos + 1,iLength - iOldPos- 1);
		iOldPos = iNewPos;
		if (nConvertType == 1)
		{
			if (uGetDiseaseDetail(strID,m_oBasicDBAccessPtr,&oStructDiseaseDetail,lErrCode) == RETOK)
			{
				strTemp = (LPCTSTR)oStructDiseaseDetail.szName;
				strPathName = strPathName + "\\" + strTemp;
			}
			else
			{
				return RETERR;
			}
		}
		else if(nConvertType == 2)
		{
			if (uGetModifierDetail(strID,m_oBasicDBAccessPtr,&oStructModifierDetail,lErrCode) == RETOK)
			{
				strTemp = (LPCTSTR)oStructModifierDetail.szName;
				strPathName.Format("%d\\%d",strPathName,strTemp);
			}
			else
			{
				return RETERR;
			}
		}
	}
	return RETOK;
}

/******************************************************************
	Title		:	Cڍ׏擾
	Function	:	uGetModifierDetail() 
	Parameters	:	CString strModifierID						CID
					IBasicDBAccessPtr m_oBasicDBAccessPtr		a{DBANZX̃IuWFNg
					StructModifierDetail *pStructModifierDetail	Cڍ׏
	Return		:	int		RETERR	:NG
							RETOK	:OK							
	Description	:	uCڍ׏擾v֐Ăяo
	Create By	:	b@@2000.06.27
******************************************************************/
int uGetModifierDetail(CString strModifierID, IBasicDBAccessPtr m_oBasicDBAccessPtr,
					   MODIFIERDETAIL *pStructModifierDetail,long &lErrCode)
{
	//IuWFNgCX^X邩𔻒f
	if(m_oBasicDBAccessPtr==NULL)
	{
		lErrCode = 275000;
		return RETERR;
	}

	memset((void*)pStructModifierDetail,0x00,sizeof(MODIFIERDETAIL));
	//BSTRCStringɕϊ
	BSTR bstrModifierID;
	bstrModifierID = strModifierID.AllocSysString();
	//DLL̍\̂`
	IResultNodeListPtr pResultNodeListPtr;
	IModifierDetailPtr pModifierDetailPtr;
	//uaڍ׏擾v֐Ăяo
	pModifierDetailPtr = m_oBasicDBAccessPtr->GetModifierDetail(bstrModifierID);
	//CuŋNG[̏ꍇ
	m_oBasicDBAccessPtr->GetLatestErrorCode(&lErrCode);
	if (lErrCode != -1){
		return RETERR;
	}

	//߂l
	CString strTmp(_T(""));
	memset((void*)pStructModifierDetail,0x00,sizeof(MODIFIERDETAIL));

	strTmp = SysAllocString(pModifierDetailPtr->GetszCode());
	_stprintf(pStructModifierDetail->szCode,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszMasanCode());
	_stprintf(pStructModifierDetail->szMasanCode,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszConnectPosKbn());
	_stprintf(pStructModifierDetail->szConnectPosKbn,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszExcluSionCode());
	_stprintf(pStructModifierDetail->szExcluSionCode,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszId());
	_stprintf(pStructModifierDetail->szID,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszKName());
	_stprintf(pStructModifierDetail->szKName,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszModifierKbn());
	_stprintf(pStructModifierDetail->szModifierKbn,"%s",strTmp);


	strTmp = SysAllocString(pModifierDetailPtr->GetszName());
	_stprintf(pStructModifierDetail->szName,"%s",strTmp);

	strTmp = SysAllocString(pModifierDetailPtr->GetszReseCode());
	_stprintf(pStructModifierDetail->szReseCode,"%s",strTmp);

	return RETOK;
}



/******************************************************************
	Title		:	aڍ׏擾
	Function	:	uGetModifierDetail() 
	Parameters	:	CString strModifierID						aID
					IBasicDBAccessPtr m_oBasicDBAccessPtr		a{DBANZX̃IuWFNg
					StructModifierDetail *pStructModifierDetail	aڍ׏
	Return		:	int		RETERR	:NG
							RETOK	:OK
	Description	:	uaڍ׏擾v֐Ăяo
	Create By	:	b@@2000.06.27
******************************************************************/
int uGetDiseaseDetail(CString strDiseaseID,IBasicDBAccessPtr m_oBasicDBAccessPtr, 
					  DISEASEDETAIL *pStructDiseaseDetail,long &lErrCode)
{
	//IuWFNgCX^X邩𔻒f
	if(m_oBasicDBAccessPtr==NULL){
		lErrCode = 275000;
		return RETERR;
	}

	memset((void*)pStructDiseaseDetail,0x00,sizeof(DISEASEDETAIL));
	//BSTRCStringɕϊ
	BSTR bstrDiseaseID;
	bstrDiseaseID = strDiseaseID.AllocSysString();
	//DLL̍\̂`
	IResultNodeListPtr pResultNodeListPtr;
	IDiseaseDetailPtr pDiseaseDetailPtr;
	//uaڍ׏擾v֐Ăяo
	pDiseaseDetailPtr = m_oBasicDBAccessPtr->GetDiseaseDetail(bstrDiseaseID);
	//CuŋNG[̏ꍇ
	m_oBasicDBAccessPtr->GetLatestErrorCode(&lErrCode);
	if (lErrCode != -1){
		return RETERR;
	}

	//߂lϊ
	CString strTmp(_T(""));

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszCode());
	_stprintf(pStructDiseaseDetail->szNorCode,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszConnectModifierKbnCode());
	_stprintf(pStructDiseaseDetail->szConnectModifierKbnCode,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszExchangeCode());
	_stprintf(pStructDiseaseDetail->szExchangeCode,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszICD10_1());
	_stprintf(pStructDiseaseDetail->szICD10_1,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszICD10_2());
	_stprintf(pStructDiseaseDetail->szICD10_2,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszICD10Precision());
	_stprintf(pStructDiseaseDetail->szICD10Precision,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszICDCandidate());
	_stprintf(pStructDiseaseDetail->szICDCandidate,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszId());
	_stprintf(pStructDiseaseDetail->szID,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszKName());
	_stprintf(pStructDiseaseDetail->szKName,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszModifierJumpInfo());
	_stprintf(pStructDiseaseDetail->szModifierJumpInfo,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszName());
	_stprintf(pStructDiseaseDetail->szName,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszReseCode());
	_stprintf(pStructDiseaseDetail->szReseCode,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszReseName());
	_stprintf(pStructDiseaseDetail->szReseName,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszResePrecision());
	_stprintf(pStructDiseaseDetail->szResePrecision,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszResembleDiseaseCode());
	_stprintf(pStructDiseaseDetail->szResembleDiseaseCode,"%s",strTmp);

	strTmp = SysAllocString(pDiseaseDetailPtr->GetszSelectKbn());
	_stprintf(pStructDiseaseDetail->szSelectKbn,"%s",strTmp);

	return RETOK;

}