/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

/*****************************************************************************************
File Name		:	uDlgDiseaseFreeSearchView.cpp
				:	aRr[Rg[̃_CAt@C
Modify History	:	ID			By			Date		Desc
					H01080302	b		2001/08/03	pX̗񌩏o̕L
*****************************************************************************************/
// uDlgDiseaseFreeSearchView.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "FXISMedicalControl.h"
#include "uDlgDiseaseFreeSearchView.h"
 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseFreeSearchView _CAO


CuDlgDiseaseFreeSearchView::CuDlgDiseaseFreeSearchView(CWnd* pParent /*=NULL*/)
	: CDialog(CuDlgDiseaseFreeSearchView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CuDlgDiseaseFreeSearchView)
	//}}AFX_DATA_INIT
}


void CuDlgDiseaseFreeSearchView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuDlgDiseaseFreeSearchView)
	DDX_Control(pDX, IDC_LIST_DISEASEFREESEARCHVIEW, m_oDiseaseFreeSearchList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuDlgDiseaseFreeSearchView, CDialog)
	//{{AFX_MSG_MAP(CuDlgDiseaseFreeSearchView)
	ON_WM_SIZE()
	ON_NOTIFY(NM_CLICK, IDC_LIST_DISEASEFREESEARCHVIEW, OnClickListDiseasefreesearchview)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_DISEASEFREESEARCHVIEW, OnDblclkListDiseasefreesearchview)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_DISEASEFREESEARCHVIEW, OnItemchangedListDiseasefreesearchview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
 

 

BOOL CuDlgDiseaseFreeSearchView::OnInitDialog() 
{
	CDialog::OnInitDialog();
	uAddHeadColumn();	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


 
#include "DiseaseFreeSearchViewCtl.h"
void CuDlgDiseaseFreeSearchView::OnSize(UINT nType, int cx, int cy) 
{
	
	CDialog::OnSize(nType, cx, cy);
		// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(((CDiseaseFreeSearchViewCtrl*)GetParent())->m_bAutoResize==TRUE)
	{		
		if(m_oDiseaseFreeSearchList.GetSafeHwnd() != NULL)
		{	
			m_oDiseaseFreeSearchList.MoveWindow(0,0,cx,cy);
			m_oDiseaseFreeSearchList.Invalidate();
			
		}
	}
	
}

void CuDlgDiseaseFreeSearchView::uSetNewStyle(DWORD dStyle, BOOL bsetbit)
{
	if(bsetbit)
		m_oDiseaseFreeSearchList.ModifyStyle(0L,dStyle);
     else
		m_oDiseaseFreeSearchList.ModifyStyle(dStyle,0L);
}

void CuDlgDiseaseFreeSearchView::uSetListItem(short nstyle)
{
	switch (nstyle)
	{
    case 0:
		m_oDiseaseFreeSearchList.ModifyStyle(0L,LVS_ICON);
		break;
	case 1:
		m_oDiseaseFreeSearchList.ModifyStyle(0L,LVS_SMALLICON);
		break;
	case 2:
		m_oDiseaseFreeSearchList.ModifyStyle(0L,LVS_LIST);
		break;
	case 3:
		m_oDiseaseFreeSearchList.ModifyStyle(0L,LVS_REPORT);
		break;	
	}
}

void CuDlgDiseaseFreeSearchView::uSetExtendedStyle(DWORD style, BOOL bsetbit)
{
	DWORD dStyle;

	dStyle = ListView_GetExtendedListViewStyle(this->m_oDiseaseFreeSearchList.m_hWnd);

	if(bsetbit)
	{
		dStyle |=style;
		ListView_SetExtendedListViewStyle(this->m_oDiseaseFreeSearchList.m_hWnd,dStyle);
	}
	else
	{
		dStyle &=~style;
		ListView_SetExtendedListViewStyle(this->m_hWnd,dStyle);
	}
}


void CuDlgDiseaseFreeSearchView::OnClickListDiseasefreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LVHITTESTINFO *lvhitestinfo = (LVHITTESTINFO*)pNMHDR;
	if (lvhitestinfo->iItem >= 0)
	{
		((CDiseaseFreeSearchViewCtrl*)
			GetParent())->uFireClick(lvhitestinfo->iItem);
	}
	*pResult = 0;
}

void CuDlgDiseaseFreeSearchView::OnDblclkListDiseasefreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	((CDiseaseFreeSearchViewCtrl*)GetParent())->uFireDblClick(); 
	 *pResult = 0;
	 
}

void CuDlgDiseaseFreeSearchView::uAddHeadColumn()
{
	LVCOLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH ;
	lvc.fmt = LVCFMT_LEFT ;
	lvc.cx = 167;
	lvc.pszText = "a";
	m_oDiseaseFreeSearchList.InsertColumn(0,&lvc);
	lvc.pszText = "`";
	lvc.cx = 100;
	m_oDiseaseFreeSearchList.InsertColumn(1,&lvc);
	lvc.pszText = "L[[h";
	lvc.cx = 100;
	m_oDiseaseFreeSearchList.InsertColumn(2,&lvc);
	lvc.pszText = "pX";
	lvc.cx = 1513;

	m_oDiseaseFreeSearchList.InsertColumn(3,&lvc);
}

void CuDlgDiseaseFreeSearchView::OnItemchangedListDiseasefreesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	int nItem = pNMListView->iItem;
	int nCount = m_oDiseaseFreeSearchList.GetSelectedCount();
	if (nItem > 0 && nCount > 0){
		((CDiseaseFreeSearchViewCtrl*)GetParent())->uFireClick(nItem);
	}

	*pResult = 0;
}
