/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

/*****************************************************************************************
File Name		:	uDlgDiseaseKeywordListView.cpp
				:	aL[[hr[Rg[̃_CAt@C
Modify History	:	ID			By			Date		Desc
					H01080302	b		2001/08/03	pX̗񌩏o̕L
*****************************************************************************************/
// uDlgDiseaseKeywordListView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uDlgDiseaseKeywordListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseKeywordListView _CAO


CuDlgDiseaseKeywordListView::CuDlgDiseaseKeywordListView(CWnd* pParent /*=NULL*/)
	: CDialog(CuDlgDiseaseKeywordListView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CuDlgDiseaseKeywordListView)
	//}}AFX_DATA_INIT
}


void CuDlgDiseaseKeywordListView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuDlgDiseaseKeywordListView)
	DDX_Control(pDX, IDC_LIST_DISEASE, m_oListCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuDlgDiseaseKeywordListView, CDialog)
	//{{AFX_MSG_MAP(CuDlgDiseaseKeywordListView)
	ON_NOTIFY(NM_CLICK, IDC_LIST_DISEASE, OnClickListDisease)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_DISEASE, OnDblclkListDisease)
	ON_WM_SIZE()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_DISEASE, OnItemchangedListDisease)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseKeywordListView bZ[W nh

BOOL CuDlgDiseaseKeywordListView::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	uAddHeadColumn();
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


/**********************************************************************************
	Title		: ColumnHeader\
	Function	: CuDlgDiseaseKeywordListView::uAddHeadColumn()
	Parameters	: Ȃ
	Return		: Void
	Description	: ColumnHeader IuWFNg\
	Create@By@: b@@2000.05.24
************************************************************************************/
void CuDlgDiseaseKeywordListView::uAddHeadColumn()
{
	LVCOLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH ;
	lvc.fmt = LVCFMT_LEFT ;
	lvc.cx = 167;
	lvc.pszText = "a";
	m_oListCtrl.InsertColumn(0,&lvc);
	lvc.pszText = "`";
	lvc.cx = 100;
	m_oListCtrl.InsertColumn(1,&lvc);
	lvc.pszText = "L[[h";
	lvc.cx = 100;
	m_oListCtrl.InsertColumn(2,&lvc);
	lvc.pszText = "pX";
//MODIFY_BEGIN		ID:H01080302
//DEL	lvc.cx = 333;
	lvc.cx = 1513;	//ADD
//MODIFY_END
	m_oListCtrl.InsertColumn(3,&lvc);
}
#include "DiseaseKeywordSearchViewCtl.h"

void CuDlgDiseaseKeywordListView::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(((CDiseaseKeywordSearchViewCtrl*)GetParent())->m_bAutoResize == TRUE)
	{
		if(m_oListCtrl.GetSafeHwnd() != NULL)
		{
			m_oListCtrl.MoveWindow(0,0,cx,cy);
			m_oListCtrl.Invalidate();
		}
	}
}
/********************************************************************************
	 Title		: ListViewStyleZbg
	 Function	: CuDlgDiseaseKeywordListView::uSetNewStyle()
	 Parameters	: long lStyleMask    
				: BOOL bSetBits
	 Return		: Void
	 Description: ListViewRg[̃X^Cݒ肷
	 Create By  : b@@2000.05.24
********************************************************************************/
void CuDlgDiseaseKeywordListView::uSetNewStyle(long lStyleMask, BOOL bSetBits)
{
	DWORD  dwStyle = ListView_GetExtendedListViewStyle(this->m_oListCtrl.m_hWnd);
	if(bSetBits)
	{
		dwStyle |= lStyleMask;
		ListView_SetExtendedListViewStyle(this->m_oListCtrl.m_hWnd,dwStyle);
	}
	else
	{	
		dwStyle &= ~lStyleMask;
		ListView_SetExtendedListViewStyle(this->m_oListCtrl.m_hWnd,dwStyle);
	}
} 



void CuDlgDiseaseKeywordListView::uModifyStyle(DWORD dStyle, BOOL bsetbit)
{
	if(bsetbit)
		m_oListCtrl.ModifyStyle(0L,dStyle);
	else
		m_oListCtrl.ModifyStyle(dStyle,0L);
}

void CuDlgDiseaseKeywordListView::OnClickListDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LVHITTESTINFO *lvhitestinfo = (LVHITTESTINFO*)pNMHDR;
	int nItem = lvhitestinfo->iItem;
	if (nItem >= 0){
		((CDiseaseKeywordSearchViewCtrl*)GetParent())->uListClick(nItem);
	}
	*pResult = 0;
}

void CuDlgDiseaseKeywordListView::OnDblclkListDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	((CDiseaseKeywordSearchViewCtrl*)GetParent())->FireDblClick();
	*pResult = 0;
}


void CuDlgDiseaseKeywordListView::OnItemchangedListDisease(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	int nItem = pNMListView->iItem;
	int nCount = m_oListCtrl.GetSelectedCount();
	if (nItem > 0 && nCount > 0){
		((CDiseaseKeywordSearchViewCtrl*)GetParent())->uListClick(nItem);
	}

	*pResult = 0;
}
