/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

/*****************************************************************************************
File Name		:	uDlgDiseaseResembleSearchView.cpp
				:	ގar[Rg[̃_CAt@C
Modify History	:	ID			By			Date		Desc
					H01080302	b		2001/08/03	pX̗񌩏o̕L
*****************************************************************************************/
// uDlgDiseaseResembleSearchView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uDlgDiseaseResembleSearchView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseResembleSearchView _CAO


CuDlgDiseaseResembleSearchView::CuDlgDiseaseResembleSearchView(CWnd* pParent /*=NULL*/)
	: CDialog(CuDlgDiseaseResembleSearchView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CuDlgDiseaseResembleSearchView)
	//}}AFX_DATA_INIT
}


void CuDlgDiseaseResembleSearchView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuDlgDiseaseResembleSearchView)
	DDX_Control(pDX, IDC_LIST_DISEASERESEMBLESEARCHVIEW, m_oDiseaseResembleSearchListView);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuDlgDiseaseResembleSearchView, CDialog)
	//{{AFX_MSG_MAP(CuDlgDiseaseResembleSearchView)
	ON_WM_SIZE()
	ON_NOTIFY(NM_CLICK, IDC_LIST_DISEASERESEMBLESEARCHVIEW, OnClickListDiseaseresemblesearchview)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuDlgDiseaseResembleSearchView bZ[W nh

BOOL CuDlgDiseaseResembleSearchView::OnInitDialog() 
{
	CDialog::OnInitDialog();

	uAddHeadColumn();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

#include "DiseaseResembleSearchViewCtl.h"

void CuDlgDiseaseResembleSearchView::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(((CDiseaseResembleSearchViewCtrl*)GetParent())->m_bAutoResize == TRUE)
	{
		if( m_oDiseaseResembleSearchListView.GetSafeHwnd()!= NULL)
		{
			m_oDiseaseResembleSearchListView.MoveWindow(0,0,cx,cy);
			m_oDiseaseResembleSearchListView.Invalidate();
		}
	}
}

void CuDlgDiseaseResembleSearchView::uSetNewStyle(DWORD style, BOOL bitset)
{
	if (bitset)
		m_oDiseaseResembleSearchListView.ModifyStyle(0L,style);
	else
		m_oDiseaseResembleSearchListView.ModifyStyle(style,0L);
}

void CuDlgDiseaseResembleSearchView::uSetExtendedStyle(DWORD style, BOOL bitset)
{
	DWORD dStyle;

	dStyle = ListView_GetExtendedListViewStyle(this->m_oDiseaseResembleSearchListView.m_hWnd);

	if(bitset)
	{
		dStyle |=style;
		ListView_SetExtendedListViewStyle(this->m_oDiseaseResembleSearchListView.m_hWnd,dStyle);
	}
	else
	{
		dStyle &=~style;
		ListView_SetExtendedListViewStyle(this->m_oDiseaseResembleSearchListView.m_hWnd,dStyle);
	}
}

void CuDlgDiseaseResembleSearchView::uSetListItem(short nstyle)
{
	switch (nstyle)
	{
    case 0:
		m_oDiseaseResembleSearchListView.ModifyStyle(0L,LVS_ICON);
		break;
	case 1:
		m_oDiseaseResembleSearchListView.ModifyStyle(0L,LVS_SMALLICON);
		break;
	case 2:
		m_oDiseaseResembleSearchListView.ModifyStyle(0L,LVS_LIST);
		break;
	case 3:
		m_oDiseaseResembleSearchListView.ModifyStyle(0L,LVS_REPORT);
		break;	
	}
}

void CuDlgDiseaseResembleSearchView::OnClickListDiseaseresemblesearchview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LVHITTESTINFO *lvhitestinfo = (LVHITTESTINFO*)pNMHDR;
	if (lvhitestinfo->iItem >= 0)
	{
		((CDiseaseResembleSearchViewCtrl*)
			GetParent())->uFireClick(lvhitestinfo->iItem);
	}
 
	*pResult = 0;
}

void CuDlgDiseaseResembleSearchView::uAddHeadColumn()
{
	LVCOLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH ;
	lvc.fmt = LVCFMT_LEFT ;
	lvc.cx = 167;
	lvc.pszText = "a";
	m_oDiseaseResembleSearchListView.InsertColumn(0,&lvc);
	lvc.pszText = "pX";
//MODIFY_BEGIN		ID:H01080302
//DEL	lvc.cx = 333;
	lvc.cx = 1513;	//ADD
//MODIFY_END
	m_oDiseaseResembleSearchListView.InsertColumn(1,&lvc);
}
