/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// uTreeCtrl.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FXISMedicalControl.h"
#include "uTreeCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuMyTreeCtrl

CuMyTreeCtrl::CuMyTreeCtrl()
{
}

CuMyTreeCtrl::~CuMyTreeCtrl()
{
}
void CuMyTreeCtrl::uSetFlag(int nFlag=0)
{
	m_nFlag = nFlag;
}

BEGIN_MESSAGE_MAP(CuMyTreeCtrl, CTreeCtrl)
	//{{AFX_MSG_MAP(CuMyTreeCtrl)
	ON_WM_PAINT()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuMyTreeCtrl bZ[W nh

 void CuMyTreeCtrl::OnPaint() 
 {
	CPaintDC dc(this); // `p̃foCX ReLXg
	// create a memory dc compatible with the paint dc
	CDC memdc;
	memdc.CreateCompatibleDC( &dc );

	dc.SetTextColor(RGB(255,255,255));


	CRect rcclip, rcclient;
	dc.GetClipBox( &rcclip );
	GetClientRect(&rcclient);

	// select a compatible bitmap into the memory dc
	CBitmap bitmap;
	bitmap.CreateCompatibleBitmap( &dc, rcclient.Width(), rcclient.Height() );
	memdc.SelectObject( &bitmap );
	
	// set clip region to be same as that in paint dc
	CRgn rgn;
	rgn.CreateRectRgnIndirect( &rcclip );
	memdc.SelectClipRgn(&rgn);
	rgn.DeleteObject();

	// first let the control do its default drawing.
	CWnd::DefWindowProc( WM_PAINT, (WPARAM)memdc.m_hDC, 0 );

	HTREEITEM hitem = GetFirstVisibleItem();
	if(hitem == 0)
		return;

	//ac[r[̏ꍇ
	if(m_nFlag == DISEASETREE)
	{
		while( hitem )
		{
			//u[gv or uXFa^ލڋʂȂv̏ꍇ 
			if(GetItemData(hitem ) == DISEASETREE || m_nDistinction == 9)
				memdc.SetTextColor(RGB(0,0,0));
			//̑̏ꍇ
			else if((POSITION) GetItemData(hitem))
			{
				POSITION pos =(POSITION) GetItemData(hitem);
				StructResultDiseaseNode  *pSRMN;
				pSRMN = m_oStructItemList.GetAt(pos);

				//ȁꍇ
				if(CString(pSRMN->strID).GetAt(0) - '0' == 1)
					memdc.SetTextColor(m_NameColor);
				//ލڂ̏ꍇ
				else
					memdc.SetTextColor(m_ClassificationColor);
			}

			//DCݒ肷
			memdc.SelectObject(this->GetFont());
			CString sitem = GetItemText(hitem );
			
			CRect rect;
			GetItemRect( hitem, &rect, true );
			//rectݒ肷
			if (hitem == GetSelectedItem())
			{
				memdc.SetTextColor(RGB(255,255,255));
				memdc.FillSolidRect(rect,GetSysColor(COLOR_HIGHLIGHT));
				memdc.DrawFocusRect(rect);
			}
			else
			{
				memdc.FillSolidRect(rect,RGB(255,255,255));
			}

			memdc.SetBkMode(TRANSPARENT);		
			memdc.TextOut(rect.left + 2, rect.top + 1,sitem);
			hitem = GetNextVisibleItem( hitem );
		}
 		dc.BitBlt( rcclip.left, rcclip.top, rcclip.Width(), rcclip.Height(), &memdc, 
					rcclip.left, rcclip.top, SRCCOPY );
		
	}
	//Cc[r[̏ꍇ
	else if(m_nFlag == MODIFYTREE)
	{
		while( hitem )
		{
			CRect rect;
			//u[gv or uXFa^ލڋʂȂv̏ꍇ 
			if(GetItemData(hitem ) == MODIFYTREE || m_nDistinction == 9)
				memdc.SetTextColor(RGB(0,0,0));
			//̑̏ꍇ
			else if((POSITION) GetItemData(hitem))
			{
				POSITION pos =(POSITION) GetItemData(hitem);
				StructResultModifierNode *pSRMN;
				pSRMN = m_StructResultModifierNodeList.GetAt(pos);
				//ȁꍇ
				if(CString(pSRMN->strID).GetAt(0) - '0' == 1)
					memdc.SetTextColor(m_NameColor);
				//ލڂ̏ꍇ
				else
					memdc.SetTextColor(m_ClassificationColor);
			}
			//DCݒ肷
			memdc.SelectObject(this->GetFont());
			CString sitem = GetItemText( hitem );
			GetItemRect( hitem, &rect, true );
			//rectݒ肷
			if (hitem == GetSelectedItem())
			{
				memdc.SetTextColor(RGB(255,255,255));
				memdc.FillSolidRect(rect,GetSysColor(COLOR_HIGHLIGHT));
				memdc.DrawFocusRect(rect);
			}
			else
			{
				memdc.FillSolidRect(rect,RGB(255,255,255));
			}
			memdc.SetBkMode(TRANSPARENT);

			memdc.TextOut(rect.left + 2, rect.top + 1, sitem);
			hitem = GetNextVisibleItem( hitem );
		}
		dc.BitBlt( rcclip.left, rcclip.top, rcclip.Width(), rcclip.Height(), &memdc, 
					rcclip.left, rcclip.top, SRCCOPY );
	}	
 }

void CuMyTreeCtrl::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	UINT nHitFlags;
	m_hItem = HitTest(point,&nHitFlags);
	m_Point.x = point.x;
	m_Point.y = point.y;

	if (nHitFlags == TVHT_ONITEMICON || 
		nHitFlags == TVHT_ONITEMLABEL || 
		nHitFlags == TVHT_ONITEMSTATEICON ||
		nHitFlags == TVHT_ONITEMBUTTON)
	{
		CTreeCtrl::OnLButtonDblClk(nFlags, point);
	}
	else
	{
		m_hItem = NULL;
	}
}

void CuMyTreeCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	UINT nHitFlags;
	m_hItem = HitTest(point,&nHitFlags);

	m_Point.x = point.x;
	m_Point.y = point.y;

	if (nHitFlags == TVHT_ONITEMICON || 
		nHitFlags == TVHT_ONITEMLABEL || 
		nHitFlags == TVHT_ONITEMSTATEICON ||
		nHitFlags == TVHT_ONITEMBUTTON){
		CTreeCtrl::OnLButtonDown(nFlags, point);
	}
	else{
		m_hItem = NULL;
	}
}

void CuMyTreeCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == VK_LEFT || nChar == VK_RIGHT){
		m_hItem=GetSelectedItem();
	}

	CTreeCtrl::OnKeyDown(nChar, nRepCnt, nFlags);
}

